;'use strict';(function(exports){var L10nLoader=function(){this.loadStarted=false;};L10nLoader.prototype.SCRIPT_URL='/shared/js/l10n.js';L10nLoader.prototype.load=function(){if(this.loadStarted){return;}
this.loadStarted=true;document.documentElement.lang='x-untranslated';var script=document.createElement('script');script.src=this.SCRIPT_URL;document.body.appendChild(script);};exports.L10nLoader=L10nLoader;})(window);;'use strict';(function(exports){var UserPress=function(el,coords){this.target=el;this.updateCoords(coords,false);};UserPress.prototype.updateCoords=function(coords,moved){this.moved=moved;this.clientX=coords.clientX;this.clientY=coords.clientY;};var UserPressManager=function(app){this._started=false;this._ignoreMouseEvents=false;this.presses=new Map();this.touchstartCounts=new WeakMap();this.app=app;};UserPressManager.prototype.onpressstart=null;UserPressManager.prototype.onpressmove=null;UserPressManager.prototype.onpressend=null;UserPressManager.prototype.MOVE_LIMIT=5;UserPressManager.prototype.start=function(){this.app.console.log('UserPressManager.start()');if(this._started){throw new Error('UserPressManager: '+'Instance should not be start()\'ed twice.');}
this._started=true;this._container=this.app.getContainer();this._container.addEventListener('touchstart',this);this._container.addEventListener('mousedown',this);this._container.addEventListener('contextmenu',this);};UserPressManager.prototype.stop=function(){this.app.console.log('UserPressManager.stop()');if(!this._started){throw new Error('UserPressManager: '+'Instance was never start()\'ed but stop() is called.');}
this._started=false;this._container.removeEventListener('touchstart',this);this._container.removeEventListener('mousedown',this);this._container.removeEventListener('mousemove',this);this._container.removeEventListener('mouseup',this);this._container.removeEventListener('mouseleave',this);this._container.removeEventListener('contextmenu',this);};UserPressManager.prototype.handleEvent=function(evt){var touch,touchId,el,i,touchstartCount;switch(evt.type){case'contextmenu':evt.preventDefault();break;case'touchstart':this._ignoreMouseEvents=true;touchstartCount=this.touchstartCounts.get(evt.target)||0;touchstartCount++;this.touchstartCounts.set(evt.target,touchstartCount);evt.target.addEventListener('touchmove',this);evt.target.addEventListener('touchend',this);evt.target.addEventListener('touchcancel',this);for(i=0;i<evt.changedTouches.length;i++){touch=evt.changedTouches[i];touchId=touch.identifier;el=touch.target;this._handleNewPress(el,touch,touchId);}
break;case'touchmove':for(i=0;i<evt.changedTouches.length;i++){touch=evt.changedTouches[i];touchId=touch.identifier;if(!this._distanceReachesLimit(touchId,touch)){continue;}
el=document.elementFromPoint(touch.clientX,touch.clientY);this._handleChangedPress(el,touch,touchId);}
break;case'touchend':case'touchcancel':touchstartCount=this.touchstartCounts.get(evt.target);touchstartCount--;if(touchstartCount){this.touchstartCounts.set(evt.target,touchstartCount);}else{evt.target.removeEventListener('touchmove',this);evt.target.removeEventListener('touchend',this);evt.target.removeEventListener('touchcancel',this);this.touchstartCounts.delete(evt.target);}
if(!this._started){return;}
for(i=0;i<evt.changedTouches.length;i++){touch=evt.changedTouches[i];touchId=touch.identifier;el=document.elementFromPoint(touch.clientX,touch.clientY);this._handleFinishPress(el,touch,touchId);}
break;case'mousedown':evt.preventDefault();if(this._ignoreMouseEvents){return;}
this._container.addEventListener('mousemove',this);this._container.addEventListener('mouseup',this);this._container.addEventListener('mouseleave',this);this._handleNewPress(evt.target,evt,'_mouse');break;case'mousemove':if(!this._distanceReachesLimit('_mouse',evt)){return;}
this._handleChangedPress(evt.target,evt,'_mouse');break;case'mouseup':case'mouseleave':this._container.removeEventListener('mousemove',this);this._container.removeEventListener('mouseup',this);this._container.removeEventListener('mouseleave',this);this._handleFinishPress(evt.target,evt,'_mouse');break;}};UserPressManager.prototype._handleNewPress=function(el,coords,id){this.app.console.info('UserPressManager._handleNewPress()');var press=new UserPress(el,coords);this.presses.set(id,press);if(typeof this.onpressstart==='function'){this.onpressstart(press,id);}};UserPressManager.prototype._handleChangedPress=function(el,coords,id){this.app.console.info('UserPressManager._handleChangedPress()');var press=this.presses.get(id);press.target=el;press.updateCoords(coords,true);if(typeof this.onpressmove==='function'){this.onpressmove(press,id);}};UserPressManager.prototype._handleFinishPress=function(el,coords,id){this.app.console.info('UserPressManager._handleFinishPress()');var press=this.presses.get(id);press.target=el;press.updateCoords(coords,press.moved||this._distanceReachesLimit(id,coords));if(typeof this.onpressend==='function'){this.onpressend(press,id);}
this.presses.delete(id);};UserPressManager.prototype._distanceReachesLimit=function(id,newCoord){var press=this.presses.get(id);var dx=press.clientX-newCoord.clientX;var dy=press.clientY-newCoord.clientY;var limit=this.MOVE_LIMIT;return(dx>=limit||dx<=-limit||dy>=limit||dy<=-limit);};exports.UserPress=UserPress;exports.UserPressManager=UserPressManager;})(window);;'use strict';(function(exports){var AlternativesCharMenuManager=function(app){this.app=app;this.isShown=false;this._originalTarget=null;this._hasMovedAwayFromOriginalTarget=false;this._menuAreaTop=this._menuAreaLeft=this._menuAreaRight=this._menuAreaBottom=0;};AlternativesCharMenuManager.prototype.start=function(){this._menuContainer=this.app.getMenuContainer();};AlternativesCharMenuManager.prototype.stop=function(){this._menuContainer=null;};AlternativesCharMenuManager.prototype.show=function(target){var alternatives=this._getAlternativesForTarget(target);if(!alternatives){return;}
var targetRect=target.getBoundingClientRect();IMERender.showAlternativesCharMenu(target,alternatives);this.isShown=true;this._originalTarget=target;this._hasMovedAwayFromOriginalTarget=false;var menuRect=this._menuContainer.getBoundingClientRect();this._menuAreaTop=Math.min(targetRect.top,menuRect.bottom);this._menuAreaLeft=Math.min(targetRect.left,menuRect.left);this._menuAreaBottom=targetRect.bottom;this._menuAreaRight=Math.max(targetRect.right,menuRect.right);};AlternativesCharMenuManager.prototype._getAlternativesForTarget=function _getAlternativesForTarget(target){var alternatives;var altMap=this.app.layoutManager.currentModifiedLayout.alt;if(this.app.upperCaseStateManager.isUpperCaseLocked){alternatives=(altMap[target.dataset.uppercaseValue].upperCaseLocked)?altMap[target.dataset.uppercaseValue].upperCaseLocked:altMap[target.dataset.uppercaseValue];}else if(this.app.upperCaseStateManager.isUpperCase){alternatives=altMap[target.dataset.uppercaseValue];}else{alternatives=altMap[target.dataset.lowercaseValue];}
if(!alternatives||!alternatives.length){return false;}
return[].concat(alternatives);};AlternativesCharMenuManager.prototype.hide=function(){if(!this.isShown){return;}
IMERender.hideAlternativesCharMenu();this.isShown=false;this._originalTarget=null;this._hasMovedAwayFromOriginalTarget=false;this._menuAreaTop=this._menuAreaLeft=this._menuAreaRight=this._menuAreaBottom=0;};AlternativesCharMenuManager.prototype.isMenuTarget=function(target){return(target.parentNode===this._menuContainer);};AlternativesCharMenuManager.prototype.getMenuTarget=function(press){if(!this.isShown){throw new Error('AlternativesCharMenuManager: '+'getMenuTarget called but menu is not shown');}
var children=this._menuContainer.children;var xOffset=press.clientX-this._menuAreaLeft-1;var menuWidth=this._menuAreaRight-this._menuAreaLeft;if(!this._hasMovedAwayFromOriginalTarget&&press.target===this._originalTarget){return children[Math.round(xOffset/menuWidth)*(children.length-1)];}
this._hasMovedAwayFromOriginalTarget=true;return children[Math.floor(xOffset/menuWidth*children.length)];};AlternativesCharMenuManager.prototype.isInMenuArea=function(press){if(!this.isShown){return false;}
return(press.clientY>=this._menuAreaTop&&press.clientY<=this._menuAreaBottom&&press.clientX>=this._menuAreaLeft&&press.clientX<=this._menuAreaRight);};exports.AlternativesCharMenuManager=AlternativesCharMenuManager;})(window);;'use strict';(function(exports){var VisualHighlightManager=function(app){this.app=app;this.highlightDelayTimers=new Map();};VisualHighlightManager.prototype.HIGHTLIGHT_DELAY_MS=85;VisualHighlightManager.prototype.start=function(){};VisualHighlightManager.prototype.stop=function(){};VisualHighlightManager.prototype.show=function(target){this.highlightDelayTimers.forEach(function(timer,target){clearTimeout(timer);this.highlightDelayTimers.delete(target);IMERender.unHighlightKey(target);},this);var showUpperCase=this.app.upperCaseStateManager.isUpperCase;IMERender.highlightKey(target,{showUpperCase:showUpperCase});};VisualHighlightManager.prototype.hide=function(target){if(this.highlightDelayTimers.has(target)){clearTimeout(this.highlightDelayTimers.get(target));}
var timer=setTimeout(function(){this.highlightDelayTimers.delete(target);IMERender.unHighlightKey(target);}.bind(this),this.HIGHTLIGHT_DELAY_MS);this.highlightDelayTimers.set(target,timer);};exports.VisualHighlightManager=VisualHighlightManager;})(window);;'use strict';(function(exports){var DefaultTargetHandler=function(target,app){this.target=target;this.app=app;this.ignoreCommitActions=false;};DefaultTargetHandler.prototype.activate=function(){this.app.console.log('DefaultTargetHandler.activate()');this.app.feedbackManager.triggerFeedback(this.target);this.app.visualHighlightManager.show(this.target);};DefaultTargetHandler.prototype.longPress=function(){this.app.console.log('DefaultTargetHandler.longPress()');if(!('longPressValue'in this.target.dataset)){return;}
this.ignoreCommitActions=true;var keyCode=parseInt(this.target.dataset.longPressKeyCode,10);this.app.inputMethodManager.currentIMEngine.click(keyCode);this.app.visualHighlightManager.hide(this.target);};DefaultTargetHandler.prototype.moveOut=function(){this.app.console.log('DefaultTargetHandler.moveOut()');this.app.visualHighlightManager.hide(this.target);};DefaultTargetHandler.prototype.moveIn=function(){this.app.console.log('DefaultTargetHandler.moveIn()');this.app.visualHighlightManager.show(this.target);};DefaultTargetHandler.prototype.commit=function(){this.app.console.log('DefaultTargetHandler.commit()');if(this.ignoreCommitActions){this.app.console.log('DefaultTargetHandler.commit()::return early');return;}
var keyCode=parseInt(this.target.dataset.keycode,10);var upperCaseKeyCode=parseInt(this.target.dataset.keycodeUpper,10);var engine=this.app.inputMethodManager.currentIMEngine;if(this.app.layoutManager.currentModifiedLayout.imEngine==='latin'){this.app.console.log('DefaultTargetHandler.commit()::latin::engine.click',keyCode,upperCaseKeyCode);engine.click(keyCode,upperCaseKeyCode);}else{var code=this.app.upperCaseStateManager.isUpperCase?upperCaseKeyCode:keyCode;this.app.console.log('DefaultTargetHandler.commit()::engine.click',code);engine.click(code);}
this.app.visualHighlightManager.hide(this.target);};DefaultTargetHandler.prototype.cancel=function(){this.app.console.log('DefaultTargetHandler.cancel()');this.app.visualHighlightManager.hide(this.target);};DefaultTargetHandler.prototype.doubleTap=function(){this.app.console.log('DefaultTargetHandler.doubleTap()');this.commit();};var NullTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};NullTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);NullTargetHandler.prototype.activate=NullTargetHandler.prototype.moveIn=NullTargetHandler.prototype.moveOut=NullTargetHandler.prototype.commit=NullTargetHandler.prototype.cancel=NullTargetHandler.prototype.doubleTap=function(){};var SpaceKeyTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};SpaceKeyTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);SpaceKeyTargetHandler.prototype.longPress=function(){this.app.targetHandlersManager.activeTargetsManager.clearAllTargets();navigator.mozInputMethod.mgmt.hide();this.app.visualHighlightManager.hide(this.target);};var CandidateSelectionTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};CandidateSelectionTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);CandidateSelectionTargetHandler.prototype.commit=function(){this.app.candidatePanelManager.hideFullPanel();var engine=this.app.inputMethodManager.currentIMEngine;if(typeof engine.select==='function'){engine.select(this.target.textContent,this.target.dataset.data);}
this.app.visualHighlightManager.hide(this.target);};var BackspaceTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);this.deleteTimeout=undefined;this.deleteInterval=undefined;this.ignoreCommitActions=false;};BackspaceTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);BackspaceTargetHandler.prototype.REPEAT_RATE=75;BackspaceTargetHandler.prototype.REPEAT_TIMEOUT=700;BackspaceTargetHandler.prototype._sendDelete=function(isRepeat){var engine=this.app.inputMethodManager.currentIMEngine;engine.click(KeyEvent.DOM_VK_BACK_SPACE,null,isRepeat);};BackspaceTargetHandler.prototype.activate=function(){this.app.feedbackManager.triggerFeedback(this.target);this.app.visualHighlightManager.show(this.target);this.deleteTimeout=setTimeout(function(){this._sendDelete(true);this.deleteInterval=setInterval(function(){this._sendDelete(true);}.bind(this),this.REPEAT_RATE);}.bind(this),this.REPEAT_TIMEOUT);};BackspaceTargetHandler.prototype.moveOut=function(){this.app.visualHighlightManager.hide(this.target);clearTimeout(this.deleteTimeout);clearInterval(this.deleteInterval);};BackspaceTargetHandler.prototype.moveIn=function(){this.ignoreCommitActions=true;};BackspaceTargetHandler.prototype.commit=function(){if(this.ignoreCommitActions){return;}
clearTimeout(this.deleteTimeout);clearInterval(this.deleteInterval);this._sendDelete(false);this.app.visualHighlightManager.hide(this.target);};BackspaceTargetHandler.prototype.cancel=function(){clearTimeout(this.deleteTimeout);clearInterval(this.deleteInterval);this.app.visualHighlightManager.hide(this.target);};var CompositeTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};CompositeTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);CompositeTargetHandler.prototype.commit=function(){var compositeString=this.target.dataset.compositeKey;var engine=this.app.inputMethodManager.currentIMEngine;for(var i=0;i<compositeString.length;i++){engine.click(compositeString.charCodeAt(i));}
this.app.visualHighlightManager.hide(this.target);};var PageSwitchingTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};PageSwitchingTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);PageSwitchingTargetHandler.prototype.commit=function(){var keyCode=parseInt(this.target.dataset.keycode,10);var page;switch(keyCode){case this.app.layoutManager.KEYCODE_BASIC_LAYOUT:page=this.app.layoutManager.LAYOUT_PAGE_DEFAULT;break;case this.app.layoutManager.KEYCODE_ALTERNATE_LAYOUT:page=this.app.layoutManager.LAYOUT_PAGE_SYMBOLS_I;break;case this.app.layoutManager.KEYCODE_SYMBOL_LAYOUT:page=this.app.layoutManager.LAYOUT_PAGE_SYMBOLS_II;break;case KeyEvent.DOM_VK_ALT:if(this.app.layoutManager.currentLayoutPage===this.app.layoutManager.LAYOUT_PAGE_SYMBOLS_I){page=this.app.layoutManager.LAYOUT_PAGE_SYMBOLS_II;}else{page=this.app.layoutManager.LAYOUT_PAGE_SYMBOLS_I;}
break;}
this.app.setLayoutPage(page);this.app.visualHighlightManager.hide(this.target);var currentIMEngine=this.app.inputMethodManager.currentIMEngine;if(typeof currentIMEngine.empty==='function'){currentIMEngine.empty();}};var CapsLockTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};CapsLockTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);CapsLockTargetHandler.prototype.commit=function(){this.app.upperCaseStateManager.switchUpperCaseState({isUpperCase:!this.app.upperCaseStateManager.isUpperCase,isUpperCaseLocked:false});this.app.visualHighlightManager.hide(this.target);};CapsLockTargetHandler.prototype.doubleTap=function(){this.app.upperCaseStateManager.switchUpperCaseState({isUpperCaseLocked:true});this.app.visualHighlightManager.hide(this.target);};var SwitchKeyboardTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};SwitchKeyboardTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);SwitchKeyboardTargetHandler.prototype.longPress=function(){this.ignoreCommitActions=true;this.app.targetHandlersManager.activeTargetsManager.clearAllTargets();navigator.mozInputMethod.mgmt.showAll();this.app.visualHighlightManager.hide(this.target);};SwitchKeyboardTargetHandler.prototype.commit=function(){if(this.ignoreCommitActions){return;}
this.app.targetHandlersManager.activeTargetsManager.clearAllTargets();navigator.mozInputMethod.mgmt.next();this.app.visualHighlightManager.hide(this.target);};var ToggleCandidatePanelTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};ToggleCandidatePanelTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);ToggleCandidatePanelTargetHandler.prototype.commit=function(){this.app.candidatePanelManager.toggleFullPanel();this.app.visualHighlightManager.hide(this.target);};var DismissSuggestionsTargetHandler=function(target,app){DefaultTargetHandler.apply(this,arguments);};DismissSuggestionsTargetHandler.prototype=Object.create(DefaultTargetHandler.prototype);DismissSuggestionsTargetHandler.prototype.commit=function(){var engine=this.app.inputMethodManager.currentIMEngine;if(typeof engine.dismissSuggestions==='function'){engine.dismissSuggestions();}
this.app.visualHighlightManager.hide(this.target);};exports.DefaultTargetHandler=DefaultTargetHandler;exports.NullTargetHandler=NullTargetHandler;exports.SpaceKeyTargetHandler=SpaceKeyTargetHandler;exports.CandidateSelectionTargetHandler=CandidateSelectionTargetHandler;exports.BackspaceTargetHandler=BackspaceTargetHandler;exports.CompositeTargetHandler=CompositeTargetHandler;exports.PageSwitchingTargetHandler=PageSwitchingTargetHandler;exports.CapsLockTargetHandler=CapsLockTargetHandler;exports.SwitchKeyboardTargetHandler=SwitchKeyboardTargetHandler;exports.ToggleCandidatePanelTargetHandler=ToggleCandidatePanelTargetHandler;exports.DismissSuggestionsTargetHandler=DismissSuggestionsTargetHandler;})(window);;'use strict';(function(exports){var TargetHandlersManager=function(app){this.handlers=undefined;this.activeTargetsManager=null;this.app=app;};TargetHandlersManager.prototype.start=function(){this.app.console.log('TargetHandlersManager.start()');this.handlers=new WeakMap();var activeTargetsManager=this.activeTargetsManager=new ActiveTargetsManager(this.app);activeTargetsManager.ontargetactivated=this._callTargetAction.bind(this,'activate',true,false);activeTargetsManager.ontargetlongpressed=this._callTargetAction.bind(this,'longPress',false,false);activeTargetsManager.ontargetmovedout=this._callTargetAction.bind(this,'moveOut',false,true);activeTargetsManager.ontargetmovedin=this._callTargetAction.bind(this,'moveIn',true,false);activeTargetsManager.ontargetcommitted=this._callTargetAction.bind(this,'commit',false,true);activeTargetsManager.ontargetcancelled=this._callTargetAction.bind(this,'cancel',false,true);activeTargetsManager.ontargetdoubletapped=this._callTargetAction.bind(this,'doubleTap',false,true);activeTargetsManager.start();};TargetHandlersManager.prototype.stop=function(){this.app.console.log('TargetHandlersManager.stop()');this.handlers=null;this.activeTargetsManager.stop();this.activeTargetsManager=null;};TargetHandlersManager.prototype._callTargetAction=function(action,setHandler,deleteHandler,target){this.app.console.log('TargetHandlersManager._callTargetAction()',action,setHandler,deleteHandler,target);var handler;if(this.handlers.has(target)){handler=this.handlers.get(target);if(setHandler){console.warn('TargetHandlersManager: '+'calling targetHandler.'+action+'() on existing handler.');}
if(deleteHandler){this.handlers.delete(target);}}else{handler=this._createHandlerForTarget(target);if(!setHandler){console.warn('TargetHandlersManager: '+'calling targetHandler.'+action+'() on non-existing handler.');}
if(!deleteHandler){this.handlers.set(target,handler);}}
handler[action]();};TargetHandlersManager.prototype._createHandlerForTarget=function(target){this.app.console.log('TargetHandlersManager._createHandlerForTarget()');var handler;if(target.classList.contains('dismiss-suggestions-button')){handler=new DismissSuggestionsTargetHandler(target,this.app);}else if('selection'in target.dataset){handler=new CandidateSelectionTargetHandler(target,this.app);}else if('compositeKey'in target.dataset){handler=new CompositeTargetHandler(target,this.app);}else if('keycode'in target.dataset){var keyCode=parseInt(target.dataset.keycode,10);switch(keyCode){case KeyEvent.DOM_VK_BACK_SPACE:handler=new BackspaceTargetHandler(target,this.app);break;case KeyEvent.DOM_VK_SPACE:handler=new SpaceKeyTargetHandler(target,this.app);break;case this.app.layoutManager.KEYCODE_BASIC_LAYOUT:case this.app.layoutManager.KEYCODE_ALTERNATE_LAYOUT:case this.app.layoutManager.KEYCODE_SYMBOL_LAYOUT:case KeyEvent.DOM_VK_ALT:handler=new PageSwitchingTargetHandler(target,this.app);break;case this.app.layoutManager.KEYCODE_SWITCH_KEYBOARD:handler=new SwitchKeyboardTargetHandler(target,this.app);break;case this.app.layoutManager.KEYCODE_TOGGLE_CANDIDATE_PANEL:handler=new ToggleCandidatePanelTargetHandler(target,this.app);break;case KeyEvent.DOM_VK_CAPS_LOCK:handler=new CapsLockTargetHandler(target,this.app);break;default:handler=new DefaultTargetHandler(target,this.app);break;}}else{handler=new NullTargetHandler(target,this.app);}
return handler;};exports.TargetHandlersManager=TargetHandlersManager;})(window);;'use strict';(function(exports){var ActiveTargetsManager=function(app){this.app=app;this.activeTargets=null;this.userPressManager=null;this.alternativesCharMenuManager=null;this.longPressTimer=undefined;this.doubleTapTimers=null;};ActiveTargetsManager.prototype.ontargetactivated=null;ActiveTargetsManager.prototype.ontargetlongpressed=null;ActiveTargetsManager.prototype.ontargetmovedout=null;ActiveTargetsManager.prototype.ontargetmovedin=null;ActiveTargetsManager.prototype.ontargetcommitted=null;ActiveTargetsManager.prototype.ontargetcancelled=null;ActiveTargetsManager.prototype.ontargetdoubletapped=null;ActiveTargetsManager.prototype.LONG_PRESS_TIMEOUT=700;ActiveTargetsManager.prototype.DOUBLE_TAP_TIMEOUT=450;ActiveTargetsManager.prototype.start=function(){this.app.console.log('ActiveTargetsManager.start()');this.activeTargets=new Map();this.doubleTapTimers=new WeakMap();var userPressManager=this.userPressManager=new UserPressManager(this.app);userPressManager.onpressstart=this._handlePressStart.bind(this);userPressManager.onpressmove=this._handlePressMove.bind(this);userPressManager.onpressend=this._handlePressEnd.bind(this);userPressManager.start();this.alternativesCharMenuManager=new AlternativesCharMenuManager(this.app);this.alternativesCharMenuManager.start();};ActiveTargetsManager.prototype.stop=function(){this.app.console.log('ActiveTargetsManager.stop()');this.activeTargets=null;this.userPressManager.stop();this.userPressManager=null;this.alternativesCharMenuManager.stop();this.alternativesCharMenuManager=null;clearTimeout(this.longPressTimer);};ActiveTargetsManager.prototype.clearAllTargets=function(){this.app.console.log('ActiveTargetsManager.clearAllTargets()');if(this.activeTargets.size){console.warn('ActiveTargetsManager: clear '+
this.activeTargets.size+' active target(s).');}
this.activeTargets.forEach(function(target,id){if(typeof this.ontargetcancelled==='function'){this.ontargetcancelled(target);}},this);this.activeTargets.clear();this.alternativesCharMenuManager.hide();clearTimeout(this.longPressTimer);};ActiveTargetsManager.prototype._handlePressStart=function(press,id){this.app.console.log('ActiveTargetsManager._handlePressStart()');if(this.alternativesCharMenuManager.isShown){return;}
this.activeTargets.forEach(function(target,id){this._handlePressEnd(press,id);},this);var target=press.target;this.activeTargets.set(id,target);if(typeof this.ontargetactivated==='function'){this.ontargetactivated(target);}
clearTimeout(this.longPressTimer);if(this.activeTargets.size===1){this.longPressTimer=setTimeout(this._handleLongPress.bind(this,press,id),this.LONG_PRESS_TIMEOUT);}};ActiveTargetsManager.prototype._handlePressMove=function(press,id){this.app.console.log('ActiveTargetsManager._handlePressMove()');if(!this.activeTargets.has(id)){return;}
var target=press.target;if(this.alternativesCharMenuManager.isShown&&this.alternativesCharMenuManager.isInMenuArea(press)){target=this.alternativesCharMenuManager.getMenuTarget(press);}
if(!target){return;}
var oldTarget=this.activeTargets.get(id);if(press.moved&&('selection'in oldTarget.dataset)){this.activeTargets.delete(id);this.ontargetcancelled(oldTarget);this.alternativesCharMenuManager.hide();clearTimeout(this.longPressTimer);return;}
if(target===oldTarget){return;}
this.activeTargets.set(id,target);if(typeof this.ontargetmovedout==='function'){this.ontargetmovedout(oldTarget,press);}
if(typeof this.ontargetmovedin==='function'){this.ontargetmovedin(target);}
if(!this.alternativesCharMenuManager.isMenuTarget(target)&&!this.alternativesCharMenuManager.isInMenuArea(press)){this.alternativesCharMenuManager.hide();}
clearTimeout(this.longPressTimer);if(this.activeTargets.size===1){this.longPressTimer=setTimeout(this._handleLongPress.bind(this,press,id),this.LONG_PRESS_TIMEOUT);}};ActiveTargetsManager.prototype._handleLongPress=function(press,id){this.app.console.log('ActiveTargetsManager._handleLongPress()');if(!this.activeTargets.has(id)){return;}
var target=this.activeTargets.get(id);if(typeof this.ontargetlongpressed==='function'){this.ontargetlongpressed(target);}
this.alternativesCharMenuManager.show(target);if(this.alternativesCharMenuManager.isShown){this._handlePressMove(press,id);}};ActiveTargetsManager.prototype._handlePressEnd=function(press,id){this.app.console.log('ActiveTargetsManager._handlePressEnd()');if(!this.activeTargets.has(id)){return;}
var target=this.activeTargets.get(id);this.activeTargets.delete(id);this.alternativesCharMenuManager.hide();clearTimeout(this.longPressTimer);var timer;if(this.doubleTapTimers.has(target)){timer=this.doubleTapTimers.get(target);clearTimeout(timer);this.doubleTapTimers.delete(target);if(typeof this.ontargetdoubletapped==='function'){this.ontargetdoubletapped(target);}}else{timer=setTimeout(function(){this.doubleTapTimers.delete(target);}.bind(this),this.DOUBLE_TAP_TIMEOUT);this.doubleTapTimers.set(target,timer);if(typeof this.ontargetcommitted==='function'){this.ontargetcommitted(target);}}};exports.ActiveTargetsManager=ActiveTargetsManager;})(window);;'use strict';(function(exports){var Keyboards={};Keyboards.alternateLayout={alt:{'1':['¹'],'2':['²'],'3':['³'],'4':['⁴'],'5':['⁵'],'6':['⁶'],'7':['⁷'],'8':['⁸'],'9':['⁹'],'0':['⁰','º'],'$':['¥','€','£','R$','¢','₠'],'?':['¿'],'!':['¡']},keys:[[{value:'1'},{value:'2'},{value:'3'},{value:'4'},{value:'5'},{value:'6'},{value:'7'},{value:'8'},{value:'9'},{value:'0'}],[{value:'@'},{value:'#'},{value:'$',className:'alternate-indicator'},{value:'&'},{value:'*'},{value:'-'},{value:'_'},{value:'/'},{value:'('},{value:')'}],[{value:'Alt',ratio:1.5,keyCode:KeyEvent.DOM_VK_ALT,className:'page-switch-key'},{value:'+',supportsSwitching:{value:','}},{value:':'},{value:';'},{value:'"'},{value:'\''},{value:'?'},{value:'!'},{value:'⌫',ratio:1.5,keyCode:KeyEvent.DOM_VK_BACK_SPACE}],[{value:'&nbsp',ratio:8,keyCode:KeyboardEvent.DOM_VK_SPACE},{value:'↵',ratio:2,keyCode:KeyEvent.DOM_VK_RETURN}]]};Keyboards.symbolLayout={alt:{'+':'±'},keys:[[{value:'¥'},{value:'€'},{value:'£'},{value:'¢'},{value:'₠'},{value:'%'},{value:'©'},{value:'®'},{value:'|'},{value:'\\'}],[{value:'~'},{value:'°C',compositeKey:'°C'},{value:'°F',compositeKey:'°F'},{value:'°'},{value:'<'},{value:'>'},{value:'['},{value:']'},{value:'{'},{value:'}'}],[{value:'Alt',ratio:1.5,keyCode:KeyEvent.DOM_VK_ALT,className:'page-switch-key'},{value:'+'},{value:'='},{value:'`'},{value:'^'},{value:'§'},{value:'¿'},{value:'¡'},{value:'⌫',ratio:1.5,keyCode:KeyEvent.DOM_VK_BACK_SPACE}],[{value:'&nbsp',ratio:8,keyCode:KeyboardEvent.DOM_VK_SPACE},{value:'↵',ratio:2,keyCode:KeyEvent.DOM_VK_RETURN}]]};Keyboards.numberLayout={width:3,keyClassName:'big-key special-key',keys:[[{value:'1'},{value:'2'},{value:'3'}],[{value:'4'},{value:'5'},{value:'6'}],[{value:'7'},{value:'8'},{value:'9'}],[{value:'.',longPressValue:','},{value:'0',longPressValue:'-'},{value:'⌫',keyCode:KeyEvent.DOM_VK_BACK_SPACE}]]};Keyboards.pinLayout={width:3,keyClassName:'big-key special-key bottom-symbol',keys:[[{value:'1'},{value:'2'},{value:'3'}],[{value:'4'},{value:'5'},{value:'6'}],[{value:'7'},{value:'8'},{value:'9'}],[{value:''},{value:'0'},{value:'⌫',keyCode:KeyEvent.DOM_VK_BACK_SPACE}]]};Keyboards.telLayout={width:3,keyClassName:'big-key special-key bottom-symbol',keys:[[{value:'1',longPressValue:'('},{value:'2',longPressValue:')'},{value:'3',longPressValue:'/'}],[{value:'4',longPressValue:'-'},{value:'5',longPressValue:'_'},{value:'6',longPressValue:','}],[{value:'7',longPressValue:':'},{value:'8',longPressValue:'.'},{value:'9',longPressValue:';'}],[{value:'*',longPressValue:'#'},{value:'0',longPressValue:'+'},{value:'⌫',keyCode:KeyEvent.DOM_VK_BACK_SPACE}]]};var LayoutLoader=function(){};LayoutLoader.prototype.SOURCE_DIR='./js/layouts/';LayoutLoader.prototype.start=function(){this._initializedLayouts={};this._layoutsPromises={};this.initLayouts();};LayoutLoader.prototype.initLayouts=function(){var Keyboards=exports.Keyboards;exports.Keyboards={};var layoutName;for(layoutName in Keyboards){if(this._initializedLayouts[layoutName]){console.warn('LayoutLoader: '+layoutName+' is overwritten.');}
this._initializedLayouts[layoutName]=Keyboards[layoutName];this._normalizeAlternatives(layoutName);if(!this._layoutsPromises[layoutName]){this._layoutsPromises[layoutName]=Promise.resolve(this._initializedLayouts[layoutName]);}}};LayoutLoader.prototype._normalizeAlternatives=function(layoutName){var mainLayout=this.getLayout(layoutName);var layouts=[mainLayout];var subLayoutNames=['alternateLayout','symbolLayout','telLayout','pinLayout','numberLayout',layoutName+'-sms'];subLayoutNames.forEach(function(name){if(name in mainLayout){layouts.push(mainLayout[name]);}});layouts.forEach(function(layout){var alt=layout.alt=layout.alt||{};var upperCase=layout.upperCase=layout.upperCase||{};var keys=Object.keys(alt);keys.forEach(function(key){var alternatives=alt[key];if(!Array.isArray(alternatives)){if(alternatives.indexOf(' ')!==-1){alternatives=alternatives.split(' ');if(alternatives.length===2&&alternatives[1]===''){alternatives.pop();}}else{alternatives=alternatives.split('');}}
alt[key]=alternatives;var upperCaseKey=upperCase[key]||key.toUpperCase();if(!alt[upperCaseKey]){var needDifferentUpperCaseLockedAlternatives=false;alt[upperCaseKey]=alternatives.map(function(key){if(key.length===1){return key.toUpperCase();}
needDifferentUpperCaseLockedAlternatives=needDifferentUpperCaseLockedAlternatives||(key.substr(1).toUpperCase()!==key.substr(1));return key[0].toUpperCase()+key.substr(1);});if(needDifferentUpperCaseLockedAlternatives){alt[upperCaseKey].upperCaseLocked=alternatives.map(function(key){return key.toUpperCase();});}}},this);},this);};LayoutLoader.prototype.getLayout=function(layoutName){return this._initializedLayouts[layoutName];};LayoutLoader.prototype.getLayoutAsync=function(layoutName){if(this._layoutsPromises[layoutName]){return this._layoutsPromises[layoutName];}
var p=new Promise(function(resolve,reject){var script=document.createElement('script');script.onload=function(){this.initLayouts();resolve(this._initializedLayouts[layoutName]);}.bind(this);script.onerror=function(){this._layoutsPromises[layoutName]=null;console.error('LayoutLoader: unable to load '+layoutName+'.');reject();}.bind(this);script.src=this.SOURCE_DIR+layoutName+'.js';document.body.appendChild(script);}.bind(this));this._layoutsPromises[layoutName]=p;return p;};exports.Keyboards=Keyboards;exports.LayoutLoader=LayoutLoader;})(window);;'use strict';(function(exports){var LayoutManager=function(app){this.app=app;this.currentLayout=null;this.currentLayoutName=undefined;this.currentForcedModifiedLayoutName=undefined;this.currentModifiedLayout=null;this.currentLayoutPage=this.LAYOUT_PAGE_DEFAULT;};LayoutManager.prototype.start=function(){this.loader=new LayoutLoader();this.loader.start();this._switchStateId=0;};LayoutManager.prototype.KEYCODE_BASIC_LAYOUT=-1;LayoutManager.prototype.KEYCODE_ALTERNATE_LAYOUT=-2;LayoutManager.prototype.KEYCODE_SWITCH_KEYBOARD=-3;LayoutManager.prototype.KEYCODE_TOGGLE_CANDIDATE_PANEL=-4;LayoutManager.prototype.KEYCODE_SYMBOL_LAYOUT=-5;LayoutManager.prototype.LAYOUT_PAGE_DEFAULT=0;LayoutManager.prototype.LAYOUT_PAGE_SYMBOLS_I=1;LayoutManager.prototype.LAYOUT_PAGE_SYMBOLS_II=2;LayoutManager.prototype.switchCurrentLayout=function(layoutName){var switchStateId=++this._switchStateId;var loaderPromise=this.loader.getLayoutAsync(layoutName);var p=loaderPromise.then(function(layout){if(switchStateId!==this._switchStateId){console.log('LayoutManager: '+'Promise is resolved after another switchCurrentLayout() call.');return Promise.reject();}
this.currentLayout=layout;this.currentLayoutName=layoutName;this.currentLayoutPage=this.LAYOUT_PAGE_DEFAULT;this.currentForcedModifiedLayoutName=undefined;this._updateModifiedLayout();}.bind(this));return p;};LayoutManager.prototype.updateForcedModifiedLayout=function(layoutName){if(!this.loader.getLayout(layoutName)){throw new Error('LayoutManager: update to a non-exist forced layout '+
layoutName);}
this.currentForcedModifiedLayoutName=layoutName;this._updateModifiedLayout();};LayoutManager.prototype.updateLayoutPage=function(page){switch(page){case this.LAYOUT_PAGE_DEFAULT:case this.LAYOUT_PAGE_SYMBOLS_I:case this.LAYOUT_PAGE_SYMBOLS_II:this.currentLayoutPage=page;this.currentForcedModifiedLayoutName=null;this._updateModifiedLayout();break;default:throw new Error('LayoutManager: undefined layout page.');}};LayoutManager.prototype._updateModifiedLayout=function(){if(!this.app.inputContext||!this.currentLayout){console.warn('LayoutManager: '+'calling _updateModifiedLayout() when there is no '+'inputContext or currentLayout.');this.currentModifiedLayout=null;return;}
var inputMode=this.app.inputContext.inputMode;var basicInputType=this.app.getBasicInputType();var supportsSwitching=this.app.supportsSwitching();var alternativeLayoutName=this._getAlternativeLayoutName(basicInputType,inputMode);var layout;if(this.currentForcedModifiedLayoutName){layout=this.loader.getLayout(this.currentForcedModifiedLayoutName);}else if(alternativeLayoutName){layout=this.currentLayout[alternativeLayoutName]||this.loader.getLayout(alternativeLayoutName);}else{layout=this.currentLayout;}
layout=Object.create(layout);var spaceKeyFindResult=this._findKey(layout,KeyboardEvent.DOM_VK_SPACE);var spaceKeyRowCount=spaceKeyFindResult.keyRowCount;var spaceKeyCount=spaceKeyFindResult.keyCount;if(!spaceKeyFindResult.keyFound){console.warn('LayoutManager:'+'No space key found. No special keys will be added.');this.currentModifiedLayout=layout;layout.layoutName=this.currentForcedModifiedLayoutName||this.currentLayoutName;layout.alternativeLayoutName=alternativeLayoutName;if(this.currentLayout.imEngine&&!layout.imEngine){layout.imEngine=this.currentLayout.imEngine;}
return;}
layout.keys=[].concat(layout.keys);var copiedRows=[];var spaceKeyRow=layout.keys[spaceKeyRowCount]=[].concat(layout.keys[spaceKeyRowCount]);copiedRows.push(spaceKeyRowCount);var spaceKeyObject=layout.keys[spaceKeyRowCount][spaceKeyCount]=Object.create(layout.keys[spaceKeyRowCount][spaceKeyCount]);var enterKeyFindResult=this._findKey(layout,KeyboardEvent.DOM_VK_RETURN);var enterKeyCount=enterKeyFindResult.keyCount;var enterKeyObject=layout.keys[spaceKeyRowCount][enterKeyCount]=Object.create(layout.keys[spaceKeyRowCount][enterKeyCount]);var pageSwitchingKeyObject=null;if(!layout.disableAlternateLayout){spaceKeyObject.ratio-=2;if(this.currentLayoutPage===this.LAYOUT_PAGE_DEFAULT){pageSwitchingKeyObject={keyCode:this.KEYCODE_ALTERNATE_LAYOUT,value:layout.alternateLayoutKey||'12&',ratio:2,ariaLabel:'alternateLayoutKey2',className:'page-switch-key'};}else{pageSwitchingKeyObject={keyCode:this.KEYCODE_BASIC_LAYOUT,value:this.currentLayout.basicLayoutKey||'ABC',ratio:2,ariaLabel:'basicLayoutKey2',className:'page-switch-key'};}
spaceKeyRow.splice(spaceKeyCount,0,pageSwitchingKeyObject);spaceKeyCount++;}
var needsSwitchingKey=supportsSwitching&&!layout.hidesSwitchKey;if(needsSwitchingKey){var imeSwitchKey={value:'&#x1f310;',ratio:1,keyCode:this.KEYCODE_SWITCH_KEYBOARD,className:'switch-key'};if(this.currentLayout.shortLabel){imeSwitchKey.value=this.currentLayout.shortLabel;imeSwitchKey.className+=' alternate-indicator';}
spaceKeyObject.ratio-=1;spaceKeyRow.splice(spaceKeyCount,0,imeSwitchKey);spaceKeyCount++;var r=layout.keys.length,c,row,key;while(r--){row=layout.keys[r];c=row.length;while(c--){key=row[c];if(key.supportsSwitching){if(copiedRows.indexOf(r)===-1){layout.keys[r]=[].concat(layout.keys[r]);copiedRows.push(r);}
layout.keys[r][c]=Object.create(key.supportsSwitching);}}}}
if(!layout.typeInsensitive){var periodKey={value:'.',ratio:1,keyCode:46};if(layout.alt&&layout.alt['.']){periodKey.className='alternate-indicator';}
var modifyType='default';if(this.currentLayoutPage===this.LAYOUT_PAGE_DEFAULT){switch(basicInputType){case'url':modifyType='url';break;case'email':modifyType='email';break;case'text':modifyType='default';break;case'search':modifyType='search';break;}}else{if('search'===basicInputType){modifyType='search';}else{modifyType='default';}}
switch(modifyType){case'url':spaceKeyObject.ratio-=2.0;spaceKeyRow.splice(spaceKeyCount,0,{value:'/',ratio:1,keyCode:47});spaceKeyCount++;spaceKeyRow.splice(spaceKeyCount+1,0,periodKey);break;case'email':spaceKeyObject.ratio-=2;spaceKeyRow.splice(spaceKeyCount,0,{value:'@',ratio:1,keyCode:64});spaceKeyCount++;spaceKeyRow.splice(spaceKeyCount+1,0,periodKey);break;case'search':if(enterKeyObject){enterKeyObject.className='search-icon';}
case'default':var overwrites=layout.textLayoutOverwrite||{};if(overwrites[',']!==false&&(!needsSwitchingKey||layout.needsCommaKey)){var commaKey={value:',',ratio:1,keyCode:44};if(overwrites[',']){commaKey.value=overwrites[','];commaKey.keyCode=overwrites[','].charCodeAt(0);}
spaceKeyObject.ratio-=1;spaceKeyRow.splice(spaceKeyCount,0,commaKey);spaceKeyCount++;}
if(overwrites['.']!==false){if(overwrites['.']){periodKey.value=overwrites['.'];periodKey.keyCode=overwrites['.'].charCodeAt(0);}
spaceKeyObject.ratio-=1;spaceKeyRow.splice(spaceKeyCount+1,0,periodKey);}
break;}}
var keyCount=layout.width?layout.width:10;if(!layout.disableAlternateLayout){if(spaceKeyCount==3&&keyCount==10){if(enterKeyObject){enterKeyObject.ratio=2.5;}
pageSwitchingKeyObject.ratio=1.5;}}
this.currentModifiedLayout=layout;layout.layoutName=this.currentForcedModifiedLayoutName||this.currentLayoutName;layout.alternativeLayoutName=alternativeLayoutName;if(this.currentLayout.imEngine&&!layout.imEngine){layout.imEngine=this.currentLayout.imEngine;}};LayoutManager.prototype._getAlternativeLayoutName=function(basicInputType,inputMode){switch(this.currentLayoutPage){case this.LAYOUT_PAGE_SYMBOLS_I:return'alternateLayout';case this.LAYOUT_PAGE_SYMBOLS_II:return'symbolLayout';}
switch(basicInputType){case'tel':return'telLayout';case'number':switch(inputMode){case'digit':return'pinLayout';default:return'numberLayout';}
break;case'text':switch(inputMode){case'digit':return'pinLayout';case'numeric':return'numberLayout';case'-moz-sms':var smsLayoutName=this.currentLayoutName+'-sms';if(this.loader.getLayout(smsLayoutName)){return smsLayoutName;}}
break;}
return'';};LayoutManager.prototype._findKey=function(layout,keyCode){var r=layout.keys.length,c,row,key;while(r--){row=layout.keys[r];c=row.length;while(c--){key=row[c];if(key.keyCode==keyCode){return{keyFound:true,keyRowCount:r,keyCount:c};}}}
return{keyFound:false,keyRowCount:-1,keyCount:-1};};exports.BASIC_LAYOUT=LayoutManager.prototype.KEYCODE_BASIC_LAYOUT;exports.ALTERNATE_LAYOUT=LayoutManager.prototype.KEYCODE_ALTERNATE_LAYOUT;exports.SWITCH_KEYBOARD=LayoutManager.prototype.KEYCODE_SWITCH_KEYBOARD;exports.TOGGLE_CANDIDATE_PANEL=LayoutManager.prototype.KEYCODE_TOGGLE_CANDIDATE_PANEL;exports.LAYOUT_PAGE_DEFAULT=LayoutManager.prototype.LAYOUT_PAGE_DEFAULT;exports.LayoutManager=LayoutManager;})(window);;'use strict';var IMERender=(function(){var ime,activeIme,menu;var getUpperCaseValue=function getUpperCaseValue(key,layout){var hasSpecialCode=SPECIAL_CODES.indexOf(key.keyCode)>-1;if(key.keyCode<0||hasSpecialCode||key.compositeKey)
return key.value;var upperCase=layout.upperCase||{};return upperCase[key.value]||key.value.toUpperCase();};var isSpecialKey=function isSpecialKeyObj(key){var hasSpecialCode=key.keyCode!==KeyEvent.DOM_VK_SPACE&&key.keyCode&&SPECIAL_CODES.indexOf(key.keyCode)!==-1;return hasSpecialCode||key.keyCode<=0;};var _menuKey,_altContainer;var layoutWidth=10;var numberOfCandidatesPerRow=8;var candidateUnitWidth;var inputMethodName;var cachedWindowHeight=-1;var cachedWindowWidth=-1;var SPECIAL_CODES=[KeyEvent.DOM_VK_BACK_SPACE,KeyEvent.DOM_VK_CAPS_LOCK,KeyEvent.DOM_VK_RETURN,KeyEvent.DOM_VK_ALT,KeyEvent.DOM_VK_SPACE];var ARIA_LABELS={'⇪':'upperCaseKey2','⌫':'backSpaceKey2','&nbsp':'spaceKey2','↵':'returnKey2','.':'periodKey2',',':'commaKey2',':':'colonKey2',';':'semicolonKey2','?':'questionMarkKey2','!':'exclamationPointKey2','(':'leftBracketKey2',')':'rightBracketKey2','"':'doubleQuoteKey2','«':'leftDoubleAngleQuoteKey2','»':'rightDoubleAngleQuoteKey2'};window.addEventListener('resize',function kr_onresize(){cachedWindowHeight=window.innerHeight;cachedWindowWidth=window.innerWidth;});var init=function kr_init(){ime=document.getElementById('keyboard');menu=document.getElementById('keyboard-accent-char-menu');cachedWindowHeight=window.innerHeight;cachedWindowWidth=window.innerWidth;};var setInputMethodName=function(name){var candidatePanel=activeIme&&activeIme.querySelector('.keyboard-candidate-panel');if(candidatePanel){if(inputMethodName)
candidatePanel.classList.remove(inputMethodName);candidatePanel.classList.add(name);}
var togglebutton=activeIme&&activeIme.querySelector('.keyboard-candidate-panel-toggle-button');if(togglebutton){if(inputMethodName)
togglebutton.classList.remove(inputMethodName);togglebutton.classList.add(name);}
inputMethodName=name;};var setUpperCaseLock=function kr_setUpperCaseLock(state){var capsLockKey=activeIme.querySelector('button:not([disabled])'+'[data-keycode="'+KeyboardEvent.DOM_VK_CAPS_LOCK+'"]');if(!capsLockKey)
return;if(state.isUpperCaseLocked){capsLockKey.classList.remove('kbr-key-active');capsLockKey.classList.add('kbr-key-hold');}else if(state.isUpperCase){capsLockKey.classList.add('kbr-key-active');capsLockKey.classList.remove('kbr-key-hold');}else{capsLockKey.classList.remove('kbr-key-active');capsLockKey.classList.remove('kbr-key-hold');}
capsLockKey.setAttribute('aria-pressed',state.isUpperCaseLocked||state.isUpperCase);};var draw=function kr_draw(layout,flags,callback){flags=flags||{};var supportsSwitching='mozInputMethod'in navigator?navigator.mozInputMethod.mgmt.supportsSwitching():false;var keyboardClass=[layout.layoutName,layout.alternativeLayoutName,(''+flags.inputType).substr(0,1),(''+flags.showCandidatePanel).substr(0,1),(''+flags.uppercase).substr(0,1),supportsSwitching].join('-');var container=document.getElementsByClassName(keyboardClass)[0];if(!container){container=document.createElement('div');container.classList.add('keyboard-type-container');container.classList.add(keyboardClass);if(layout.specificCssRule){container.classList.add(layout.layoutName);}
buildKeyboard(container,flags,layout);ime.appendChild(container);}
if(activeIme!==container){if(activeIme){activeIme.style.display='none';delete activeIme.dataset.active;}
container.style.display='block';container.dataset.active=true;activeIme=container;resizeUI(layout,callback);}
else if((ime.classList.contains('landscape')&&screenInPortraitMode())||(ime.classList.contains('portrait')&&!screenInPortraitMode())){resizeUI(layout,callback);}
else{if(callback){requestAnimationFrame(callback);}}};var buildKeyboard=function kr_build(container,flags,layout){flags=flags||{};layoutWidth=layout.width||10;var totalWidth=ime.clientWidth;var placeHolderWidth=totalWidth/layoutWidth;layout.upperCase=layout.upperCase||{};var content=document.createDocumentFragment();layout.keys.forEach((function buildKeyboardRow(row,nrow){var kbRow=document.createElement('div');var rowLayoutWidth=0;kbRow.classList.add('keyboard-row');kbRow.classList.add('row'+nrow);if(nrow===layout.keys.length-1){kbRow.classList.add('keyboard-last-row');}
row.forEach((function buildKeyboardColumns(key){var keyChar=key.value;if(key.hidden&&key.hidden.indexOf(flags.inputType)!==-1)
return;if(key.visible&&key.visible.indexOf(flags.inputType)===-1)
return;var upperCaseKeyChar=getUpperCaseValue(key,layout);var code=key.keyCode||keyChar.charCodeAt(0);var upperCode=key.keyCode||upperCaseKeyChar.charCodeAt(0);var attributeList=[];var className='';if(isSpecialKey(key)){className='special-key';}else{attributeList.push({key:'role',value:'key'});if(layout.keyClassName){className=layout.keyClassName;}}
if(key.className){className+=' '+key.className;}
var ratio=key.ratio||1;rowLayoutWidth+=ratio;var outputChar=flags.uppercase?upperCaseKeyChar:keyChar;var keyWidth=placeHolderWidth*ratio;var dataset=[];dataset.push({'key':'keycode','value':code});dataset.push({'key':'keycodeUpper','value':upperCode});if(key.compositeKey){dataset.push({'key':'compositeKey','value':key.compositeKey});}
if(key.disabled){attributeList.push({key:'disabled',value:'true'});}
if(key.ariaLabel||ARIA_LABELS[key.value]){attributeList.push({key:'data-l10n-id',value:key.ariaLabel||ARIA_LABELS[key.value]});}else{attributeList.push({key:'aria-label',value:key.ariaLabel||key.value});}
if(key.longPressValue){var longPressKeyCode=key.longPressKeyCode||key.longPressValue.charCodeAt(0);dataset.push({'key':'longPressValue','value':key.longPressValue});dataset.push({'key':'longPressKeyCode','value':longPressKeyCode});}
dataset.push({'key':'lowercaseValue','value':keyChar});dataset.push({'key':'uppercaseValue','value':upperCaseKeyChar});kbRow.appendChild(buildKey(outputChar,className,keyWidth+'px',dataset,key.longPressValue,attributeList));}));kbRow.dataset.layoutWidth=rowLayoutWidth;content.appendChild(kbRow);}));container.innerHTML='';container.appendChild(content);if(flags.showCandidatePanel){container.insertBefore(candidatePanelToggleButtonCode(),container.firstChild);container.insertBefore(candidatePanelCode(),container.firstChild);showCandidates([]);container.classList.add('candidate-panel');}else{container.classList.remove('candidate-panel');}};var highlightKey=function kr_updateKeyHighlight(key,options){options=options||{};key.classList.add('highlighted');if(!options.showUpperCase){key.classList.add('lowercase');}};var unHighlightKey=function kr_unHighlightKey(key){key.classList.remove('highlighted');key.classList.remove('lowercase');};var toggleCandidatePanel=function(expand){var candidatePanel=activeIme.querySelector('.keyboard-candidate-panel');candidatePanel.scrollTop=candidatePanel.scrollLeft=0;toggleCandidatePanelWithoutResetScroll(expand);};var toggleCandidatePanelWithoutResetScroll=function(expand){if(expand){ime.classList.remove('candidate-panel');ime.classList.add('full-candidate-panel');}else{ime.classList.remove('full-candidate-panel');ime.classList.add('candidate-panel');}};var isFullCandidataPanelShown=function(){return ime.classList.contains('full-candidate-panel');};var showCandidates=function(candidates){if(!activeIme)
return;if(inputMethodName=='vietnamese'&&candidates.length){numberOfCandidatesPerRow=candidates.length;candidateUnitWidth=Math.floor(ime.clientWidth/numberOfCandidatesPerRow);}
var candidatePanel=activeIme.querySelector('.keyboard-candidate-panel');var candidatePanelToggleButton=activeIme.querySelector('.keyboard-candidate-panel-toggle-button');if(candidatePanel){candidatePanel.dataset.candidateIndicator=0;var docFragment=document.createDocumentFragment();if(inputMethodName=='latin'){var dismissButton=candidatePanel.querySelector('.dismiss-suggestions-button');dismissButton.classList.add('hide');if(candidates.length>0){dismissButton.classList.remove('hide');}
var suggestContainer=candidatePanel.querySelector('.suggestions-container');suggestContainer.innerHTML='';for(var i=0;i<4;i++){suggestContainer.classList.remove('has'+i);}
suggestContainer.classList.add('has'+candidates.length);candidates.forEach(function buildCandidateEntry(candidate){if(!candidate)return;var div=document.createElement('div');div.setAttribute('role','presentation');suggestContainer.appendChild(div);var text,data,correction=false;if(typeof candidate==='string'){if(candidate[0]==='*'){candidate=candidate.substring(1);correction=true;}
data=text=candidate;}
else{text=candidate[0];data=candidate[1];}
var span=fitText(div,text);span.setAttribute('role','option');span.dataset.selection=true;span.dataset.data=data;if(correction)
span.classList.add('autocorrect');function fitText(container,text){container.textContent='';if(!text)
return null;var span=document.createElement('span');span.textContent=text;container.appendChild(span);var limit=.6;var scale=IMERender.getScale(span,candidates.length);if(scale<limit){var charactersReplaced=text.length%2;while(scale<limit&&charactersReplaced<text.length-2){charactersReplaced+=2;var halflen=(text.length-charactersReplaced)/2;span.textContent=text.substring(0,halflen)+'…'+
text.substring(text.length-halflen);scale=IMERender.getScale(span,candidates.length);}}
span.style.display='inline-block';if(scale<1){span.style.width=(100/scale)+'%';span.style.transformOrigin='left';span.style.transform='scale('+scale+')';}
else{span.style.width='100%';}
return span;}});}else{candidatePanel.innerHTML='';candidatePanelToggleButton.style.display='none';toggleCandidatePanelWithoutResetScroll(false);docFragment=candidatesFragmentCode(1,candidates,true);candidatePanel.appendChild(docFragment);}}};var showMoreCandidates=function(rowLimit,candidates){if(!rowLimit)rowLimit=-1;if(!candidates)return;activeIme.querySelector('.keyboard-candidate-panel').appendChild(candidatesFragmentCode(rowLimit,candidates));};var getNumberOfCandidatesPerRow=function(){return numberOfCandidatesPerRow;};var candidatesFragmentCode=function(rowLimit,candidates,indentFirstRow){var candidatePanel=activeIme.querySelector('.keyboard-candidate-panel');var candidatePanelToggleButton=activeIme.querySelector('.keyboard-candidate-panel-toggle-button');var docFragment=document.createDocumentFragment();if(candidates.length==0){candidatePanel.dataset.rowCount=0;return docFragment;}
var rowDiv=document.createElement('div');rowDiv.classList.add('candidate-row');if(indentFirstRow){rowDiv.classList.add('candidate-row-first');}
var nowUnit=0;var rowCount=0;if(rowLimit<0){rowLimit=Number.Infinity;}
var candidatesLength=candidates.length;for(var i=0;i<candidatesLength;i++){var cand,data;if(typeof candidates[i]=='string'){cand=data=candidates[i];}else{cand=candidates[i][0];data=candidates[i][1];}
var unit=(cand.length>>1)+1;if(inputMethodName=='vietnamese'){unit=1;}
var span=document.createElement('span');span.textContent=cand;span.dataset.selection=true;span.dataset.data=data;span.style.width=(unit*candidateUnitWidth-2)+'px';nowUnit+=unit;var needBreak=false;if(rowCount==0&&indentFirstRow&&nowUnit==numberOfCandidatesPerRow&&i!=candidatesLength-1){needBreak=true;}
if(nowUnit>numberOfCandidatesPerRow||needBreak){if(rowCount==0){candidatePanelToggleButton.style.display='block';}
if(rowCount>=rowLimit-1){break;}
docFragment.appendChild(rowDiv);rowCount++;rowDiv=document.createElement('div');rowDiv.classList.add('candidate-row');nowUnit=unit;}
rowDiv.appendChild(span);}
if(i!=candidatesLength){candidatePanel.dataset.truncated=true;}else{delete candidatePanel.dataset.truncated;}
candidatePanel.dataset.rowCount=rowCount+1;candidatePanel.dataset.candidateIndicator=parseInt(candidatePanel.dataset.candidateIndicator)+i;docFragment.appendChild(rowDiv);rowDiv=null;return docFragment;};var showAlternativesCharMenu=function(key,altChars){var content=document.createDocumentFragment();var left=(cachedWindowWidth/2>key.offsetLeft);if(!left){menu.classList.add('kbr-menu-left');altChars=altChars.reverse();}
var keycharwidth=key.dataset.compositeKey?key.dataset.compositeKey.length:1;altChars.forEach(function(alt,index){var dataset=alt.length==1?[{'key':'keycode','value':alt.charCodeAt(0)},{'key':'keycodeUpper','value':alt.toUpperCase().charCodeAt(0)}]:[{'key':'compositeKey','value':alt}];var width=0.75*key.offsetWidth/keycharwidth*alt.length;var attributeList=[];if(ARIA_LABELS[alt]){attributeList.push({key:'data-l10n-id',value:ARIA_LABELS[alt]});}else{attributeList.push({key:'aria-label',value:alt});}
attributeList.push({key:'role',value:'key'});content.appendChild(buildKey(alt,'',width+'px',dataset,null,attributeList));});menu.innerHTML='';menu.appendChild(content);_altContainer=document.createElement('div');_altContainer.style.display='inline-block';_altContainer.style.width=key.style.width;_altContainer.innerHTML=key.innerHTML;_altContainer.className=key.className;_altContainer.classList.add('kbr-menu-on');_menuKey=key;key.parentNode.replaceChild(_altContainer,key);_altContainer.querySelectorAll('.visual-wrapper > span')[0].appendChild(menu);menu.style.display='block';function getWindowLeft(obj){var left;left=obj.offsetLeft;while(!!(obj=obj.offsetParent)){left+=obj.offsetLeft;}
return left;}
var alternativesLeft=getWindowLeft(menu);var alternativesRight=alternativesLeft+menu.offsetWidth;var offset;if(alternativesLeft<0||alternativesRight>cachedWindowWidth){if(left){offset=parseInt(getComputedStyle(menu).left);if(alternativesLeft<0){offset+=-alternativesLeft;}
else if(alternativesRight>cachedWindowWidth){offset-=(alternativesRight-cachedWindowWidth);}
menu.style.left=offset+'px';}
else{offset=parseInt(getComputedStyle(menu).right);if(alternativesRight>cachedWindowWidth){offset+=(alternativesRight-cachedWindowWidth);}
else if(alternativesLeft<0){offset+=alternativesLeft;}
menu.style.right=offset+'px';}}};var hideAlternativesCharMenu=function km_hideAlternativesCharMenu(){menu.style.display='none';menu.className='';menu.innerHTML='';if(_altContainer){_altContainer.parentNode.replaceChild(_menuKey,_altContainer);}
menu.style.left='';menu.style.right='';};var _keyArray=[];var resizeUI=function(layout,callback){function setKeyWidth(){[].forEach.call(rows,function(rowEl,rIx){var rowLayoutWidth=parseInt(rowEl.dataset.layoutWidth,10);var keysInRow=rowEl.childNodes.length;[].forEach.call(rowEl.childNodes,function(keyEl,kIx){var key=layout.keys[rIx][kIx];var wrapperRatio=key.ratio||1;var keyRatio=wrapperRatio;if(kIx===0){keyEl.classList.add('float-key-first');keyRatio=wrapperRatio+((layoutWidth-rowLayoutWidth)/2);}
else if(kIx===keysInRow-1){keyEl.classList.add('float-key-last');keyRatio=wrapperRatio+((layoutWidth-rowLayoutWidth)/2);}
keyEl.style.width=(placeHolderWidth|0)*keyRatio+'px';if(keyRatio!==wrapperRatio){var wrapperEl=keyEl.querySelector('.visual-wrapper');wrapperEl.style.width=(placeHolderWidth*wrapperRatio|0)+'px';}});});requestAnimationFrame(getVisualData);}
function getVisualData(){for(var r=0,row;row=rows[r];r++){for(var k=0,key;key=row.childNodes[k];k++){var visualKey=key.querySelector('.visual-wrapper');_keyArray.push({code:key.dataset.keycode|0,x:visualKey.offsetLeft,y:visualKey.offsetTop,width:visualKey.clientWidth,height:visualKey.clientHeight});}}
candidateUnitWidth=Math.floor(ime.clientWidth/numberOfCandidatesPerRow);[].forEach.call(ime.querySelectorAll('.candidate-row span'),function(item){var unit=(item.textContent.length>>1)+1;if(inputMethodName=='vietnamese'){unit=1;}
item.style.width=(unit*candidateUnitWidth-2)+'px';});if(callback){callback();}}
var changeScale;if(screenInPortraitMode()){changeScale=cachedWindowWidth/32;document.documentElement.style.fontSize=changeScale+'px';ime.classList.remove('landscape');ime.classList.add('portrait');}else{changeScale=cachedWindowWidth/64;document.documentElement.style.fontSize=changeScale+'px';ime.classList.remove('portrait');ime.classList.add('landscape');}
_keyArray=[];if(!layout||!activeIme){return;}
[].forEach.call(ime.querySelectorAll('.visual-wrapper[style]'),function(item){item.style.width='';});layoutWidth=layout.width||10;var totalWidth=cachedWindowWidth;var placeHolderWidth=totalWidth/layoutWidth;var rows=activeIme.querySelectorAll('.keyboard-row');setKeyWidth();};var translateElement=function(el){if(!navigator.mozL10n||navigator.mozL10n.readyState!=='complete'){return;}
navigator.mozL10n.translate(el);};var candidatePanelCode=function(){var candidatePanel=document.createElement('div');candidatePanel.setAttribute('role','group');candidatePanel.dataset.l10nId='wordSuggestions2';translateElement(candidatePanel);candidatePanel.classList.add('keyboard-candidate-panel');if(inputMethodName)
candidatePanel.classList.add(inputMethodName);var dismissButton=document.createElement('div');dismissButton.classList.add('dismiss-suggestions-button');dismissButton.classList.add('hide');dismissButton.setAttribute('role','button');dismissButton.dataset.l10nId='dismiss2';translateElement(dismissButton);candidatePanel.appendChild(dismissButton);var suggestionContainer=document.createElement('div');suggestionContainer.classList.add('suggestions-container');suggestionContainer.setAttribute('role','listbox');candidatePanel.appendChild(suggestionContainer);return candidatePanel;};var candidatePanelToggleButtonCode=function(){var toggleButton=document.createElement('span');toggleButton.classList.add('keyboard-candidate-panel-toggle-button');toggleButton.dataset.keycode=-4;if(inputMethodName){toggleButton.classList.add(inputMethodName);}
toggleButton.style.width=Math.floor(ime.clientWidth/numberOfCandidatesPerRow)+'px';return toggleButton;};var buildKey=function buildKey(label,className,width,dataset,altNote,attributeList){var altNoteNode;if(altNote){altNoteNode=document.createElement('div');altNoteNode.className='alt-note';altNoteNode.textContent=altNote;}
var contentNode=document.createElement('button');contentNode.className='keyboard-key '+className;contentNode.style.width=width;if(attributeList){attributeList.forEach(function(attribute){contentNode.setAttribute(attribute.key,attribute.value);if(attribute.key==='data-l10n-id'){translateElement(contentNode);}});}
dataset.forEach(function(data){contentNode.dataset[data.key]=data.value;});var vWrapperNode=document.createElement('span');vWrapperNode.className='visual-wrapper';var labelNode=document.createElement('span');labelNode.innerHTML=label;labelNode.className='key-element';labelNode.dataset.label=label;vWrapperNode.appendChild(labelNode);labelNode=document.createElement('span');labelNode.innerHTML=label;labelNode.className='uppercase popup';vWrapperNode.appendChild(labelNode);labelNode=document.createElement('span');labelNode.innerHTML=contentNode.dataset.lowercaseValue;labelNode.className='lowercase popup';vWrapperNode.appendChild(labelNode);if(altNoteNode){vWrapperNode.appendChild(altNoteNode);}
contentNode.appendChild(vWrapperNode);return contentNode;};var getWidth=function getWidth(){if(!activeIme)
return 0;return cachedWindowWidth;};var getHeight=function getHeight(){if(!activeIme)
return 0;var scale=screenInPortraitMode()?cachedWindowWidth/32:cachedWindowWidth/64;var height=(activeIme.querySelectorAll('.keyboard-row').length*(5.1*scale));if(activeIme.classList.contains('candidate-panel')){if(activeIme.querySelector('.keyboard-candidate-panel').classList.contains('latin')){height+=(3.1*scale);}
else{height+=(3.2*scale);}}
return height|0;};var getKeyArray=function getKeyArray(){return _keyArray;};var getKeyWidth=function getKeyWidth(){if(!activeIme)
return 0;return Math.ceil(ime.clientWidth/layoutWidth);};var getKeyHeight=function getKeyHeight(){if(!activeIme)
return 0;var rows=activeIme.querySelectorAll('.keyboard-row');var rowCount=rows.length||3;var candidatePanel=activeIme.querySelector('.keyboard-candidate-panel');var candidatePanelHeight=candidatePanel?candidatePanel.clientHeight:0;return Math.ceil((ime.clientHeight-candidatePanelHeight)/rowCount);};var scaleContext=null;var getScale=function(element,noOfSuggestions){if(!scaleContext){scaleContext=document.createElement('canvas').getContext('2d',{willReadFrequently:true});scaleContext.font='2rem sans-serif';}
var elementWidth=scaleContext.measureText(element.textContent).width;var cw=(cachedWindowWidth-36)/noOfSuggestions|0;cw-=6;var s=cw/elementWidth;if(s>=1)
return 1;if(s>=.8)
return.8;if(s>=.7)
return.7;if(s>=.65)
return.65;if(s>=.6)
return.6;return s;};var screenInPortraitMode=function(){return cachedWindowWidth<=cachedWindowHeight;};var _t={};function startTime(key){}
function endTime(key){}
return{'init':init,'setInputMethodName':setInputMethodName,'draw':draw,get ime(){return ime;},get menu(){return menu;},'highlightKey':highlightKey,'unHighlightKey':unHighlightKey,'showAlternativesCharMenu':showAlternativesCharMenu,'hideAlternativesCharMenu':hideAlternativesCharMenu,'setUpperCaseLock':setUpperCaseLock,'resizeUI':resizeUI,'showCandidates':showCandidates,'getWidth':getWidth,'getHeight':getHeight,'getKeyArray':getKeyArray,'getKeyWidth':getKeyWidth,'getKeyHeight':getKeyHeight,'getScale':getScale,'showMoreCandidates':showMoreCandidates,'toggleCandidatePanel':toggleCandidatePanel,'isFullCandidataPanelShown':isFullCandidataPanelShown,'getNumberOfCandidatesPerRow':getNumberOfCandidatesPerRow,'candidatePanelCode':candidatePanelCode,get activeIme(){return activeIme;},set activeIme(v){activeIme=v;},get candidatePanel(){return activeIme&&activeIme.querySelector('.keyboard-candidate-panel');},setCachedWindowSize:function(width,height){cachedWindowWidth=width;cachedWindowHeight=height;}};})();;'use strict';(function(exports){var KeyboardConsole=function KeyboardConsole(){this._timers=null;};KeyboardConsole.prototype.start=function(){var timers=this._timers=new Map();timers.set('domLoading',performance.timing.domLoading);this._startTime=Date.now();};KeyboardConsole.prototype.LOG_LEVEL=0;KeyboardConsole.prototype.trace=function(){if(this.LOG_LEVEL<3){return;}
console.trace.apply(console,arguments);};KeyboardConsole.prototype.time=function(timerName){if(this.LOG_LEVEL<2){return;}
console.time(timerName);};KeyboardConsole.prototype.timeEnd=function(timerName){if(this.LOG_LEVEL<2){return;}
if(this._timers.has(timerName)){console.log(timerName+': '+
(Date.now()-this._timers.get(timerName))+'ms');return;}
console.timeEnd(timerName);};KeyboardConsole.prototype.log=function(){if(this.LOG_LEVEL<2){return;}
console.log.apply(console,arguments);};KeyboardConsole.prototype.info=function(){if(this.LOG_LEVEL<1){return;}
console.info.apply(console,arguments);};exports.KeyboardConsole=KeyboardConsole;})(window);;'use strict';(function(exports){var InputMethods={};InputMethods['default']={init:function(glue){this._glue=glue;},click:function(keyCode,isRepeat){this._glue.sendKey(keyCode,isRepeat);},displaysCandidates:function(){return false;}};var InputMethodGlue=function InputMethodGlue(){this.app=null;};InputMethodGlue.prototype.SOURCE_DIR='./js/imes/';InputMethodGlue.prototype.init=function(app,imEngineName){this.app=app;this.path=this.SOURCE_DIR+imEngineName;};InputMethodGlue.prototype.sendCandidates=function(candidates){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call sendCandidates() when '+'inputContext does not exist.');return;}
this.app.candidatePanelManager.updateCandidates(candidates);};InputMethodGlue.prototype.setComposition=function(symbols,cursor){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call setComposition() when '+'inputContext does not exist.');return;}
cursor=cursor||symbols.length;this.app.console.info('inputContext.setComposition()');this.app.inputContext.setComposition(symbols,cursor).catch(function(e){console.warn('InputMethodGlue: setComposition() rejected with error',e);this.app.console.log(symbols,cursor);return Promise.reject(e);}.bind(this));};InputMethodGlue.prototype.endComposition=function(text){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call endComposition() when '+'inputContext does not exist.');return;}
text=text||'';this.app.console.info('inputContext.endComposition()');return this.app.inputContext.endComposition(text).catch(function(e){console.warn('InputMethodGlue: endComposition() rejected with error',e);this.app.console.log(text);return Promise.reject(e);}.bind(this));};InputMethodGlue.prototype.sendKey=function(keyCode,isRepeat){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call sendKey() when '+'inputContext does not exist.');return Promise.reject();}
var promise;this.app.console.info('inputContext.sendKey()');switch(keyCode){case KeyEvent.DOM_VK_BACK_SPACE:promise=this.app.inputContext.sendKey(keyCode,0,0,isRepeat);break;case KeyEvent.DOM_VK_RETURN:promise=this.app.inputContext.sendKey(keyCode,0,0);break;default:promise=this.app.inputContext.sendKey(0,keyCode,0);break;}
return promise.catch(function(e){console.warn('InputMethodGlue: sendKey() rejected with error',e);this.app.console.log(keyCode,isRepeat);return Promise.reject(e);}.bind(this));};InputMethodGlue.prototype.sendString=function(str){this.app.console.trace();for(var i=0;i<str.length;i++){this.sendKey(str.charCodeAt(i));}};InputMethodGlue.prototype.alterKeyboard=function(layoutName){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call alterKeyboard() when '+'inputContext does not exist.');return;}
this.app.layoutManager.updateForcedModifiedLayout(layoutName);this.app.layoutRenderingManager.updateLayoutRendering();};InputMethodGlue.prototype.setLayoutPage=function(newpage){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call setLayoutPage() when '+'inputContext does not exist.');return;}
if(newpage!==this.app.layoutManager.LAYOUT_PAGE_DEFAULT){throw new Error('InputMethodGlue: '+'imEngine is only allowed to switch to default page');}
this.app.setLayoutPage(newpage);};InputMethodGlue.prototype.setUpperCase=function(state){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call setUpperCase() when '+'inputContext does not exist.');return;}
this.app.upperCaseStateManager.switchUpperCaseState(state);};InputMethodGlue.prototype.isCapitalized=function(){this.app.console.trace();return this.app.upperCaseStateManager.isUpperCase;};InputMethodGlue.prototype.replaceSurroundingText=function(text,offset,length){this.app.console.trace();if(!this.app.inputContext){console.warn('InputMethodGlue: call replaceSurroundingText() when '+'inputContext does not exist.');return Promise.reject();}
this.app.console.info('inputContext.replaceSurroundingText()');var p=this.app.inputContext.replaceSurroundingText(text,offset,length);p.catch(function(e){console.warn('InputMethodGlue: '+'replaceSurroundingText() rejected with error',e);this.app.console.log(text,offset,length);return Promise.reject(e);}.bind(this));return p;};InputMethodGlue.prototype.getNumberOfCandidatesPerRow=function(){return this.app.getNumberOfCandidatesPerRow();};var InputMethodLoader=function(app){this.app=app;};InputMethodLoader.prototype.SOURCE_DIR='./js/imes/';InputMethodLoader.prototype.start=function(){this._initializedIMEngines={};this._imEnginesPromises={};this.initPreloadedInputMethod();};InputMethodLoader.prototype.initPreloadedInputMethod=function(){var imEngineName;var InputMethods=exports.InputMethods;for(imEngineName in InputMethods){this.initInputMethod(imEngineName);this._imEnginesPromises[imEngineName]=Promise.resolve(this._initializedIMEngines[imEngineName]);}};InputMethodLoader.prototype.getInputMethod=function(imEngineName){return this._initializedIMEngines[imEngineName];};InputMethodLoader.prototype.getInputMethodAsync=function(imEngineName){if(this._imEnginesPromises[imEngineName]){return this._imEnginesPromises[imEngineName];}
var p=new Promise(function(resolve,reject){var script=document.createElement('script');script.onload=function(){this.initInputMethod(imEngineName);resolve(this._initializedIMEngines[imEngineName]);}.bind(this);script.onerror=function(){this._imEnginesPromises[imEngineName]=null;console.error('InputMethodLoader: unable to load '+imEngineName+'.');reject();}.bind(this);script.src=this.SOURCE_DIR+imEngineName+'/'+imEngineName+'.js';document.body.appendChild(script);}.bind(this));this._imEnginesPromises[imEngineName]=p;return p;};InputMethodLoader.prototype.initInputMethod=function(imEngineName){var InputMethods=exports.InputMethods;if(!(imEngineName in InputMethods)){throw new Error('InputMethodLoader: '+imEngineName+' did not expose itself correctly.');}
var imEngine=InputMethods[imEngineName];var glue=new InputMethodGlue();glue.init(this.app,imEngineName);this._initializedIMEngines[imEngineName]=InputMethods[imEngineName];InputMethods[imEngineName]=null;imEngine.init(glue);};var InputMethodManager=function InputMethodManager(app){this._targetIMEngineName=null;this.currentIMEngine=null;this.app=app;};InputMethodManager.prototype.start=function(){this.loader=new InputMethodLoader(this.app);this.loader.start();this.imEngineSettings=new IMEngineSettings();this.imEngineSettings.promiseManager=this.app.settingsPromiseManager;this.imEngineSettings.initSettings().catch(function rejected(){console.error('Fatal Error! Failed to get initial imEngine settings.');});this.currentIMEngine=this.loader.getInputMethod('default');this._switchStateId=0;this._inputContextData=null;};InputMethodManager.prototype.updateInputContextData=function(){this.app.console.log('InputMethodManager.updateInputContextData()');if(!this.app.inputContext||this._inputContextData){return;}
var inputContext=this.app.inputContext;var p=inputContext.getText().then(function(value){this.app.console.log('updateInputContextData:promise resolved');return{type:inputContext.inputType,inputmode:inputContext.inputMode,selectionStart:inputContext.selectionStart,selectionEnd:inputContext.selectionEnd,value:value};}.bind(this),function(error){console.warn('InputMethodManager: inputcontext.getText() was rejected.');return{type:inputContext.inputType,inputmode:inputContext.inputMode,selectionStart:inputContext.selectionStart,selectionEnd:inputContext.selectionEnd,value:''};}.bind(this));this._inputContextData=p;};InputMethodManager.prototype.switchCurrentIMEngine=function(imEngineName){this.app.console.log('InputMethodManager.switchCurrentIMEngine()',imEngineName);var switchStateId=++this._switchStateId;this.app.console.time('switchCurrentIMEngine'+switchStateId);var dataPromise=this._inputContextData;this._inputContextData=null;if(!dataPromise&&imEngineName!=='default'){console.warn('InputMethodManager: switchCurrentIMEngine() called '+'without calling updateInputContextData() first.');}
if(this.currentIMEngine&&this.currentIMEngine.deactivate){this.app.console.log('InputMethodManager::currentIMEngine.deactivate()');this.currentIMEngine.deactivate();}
if(this.app.inputContext){this.app.inputContext.removeEventListener('selectionchange',this);this.app.inputContext.removeEventListener('surroundingtextchange',this);}
this.currentIMEngine=this.loader.getInputMethod('default');var loaderPromise=this.loader.getInputMethodAsync(imEngineName);var settingsPromise=this.imEngineSettings.initSettings();var p=Promise.all([loaderPromise,dataPromise,settingsPromise]).then(function(values){if(switchStateId!==this._switchStateId){console.warn('InputMethodManager: '+'Promise is resolved after another switchCurrentIMEngine() call.');return Promise.reject();}
var imEngine=values[0];if(typeof imEngine.activate==='function'){var dataValues=values[1];var settingsValues=values[2];var currentLayout=this.app.layoutManager.currentLayout;var correctPunctuation='autoCorrectPunctuation'in currentLayout?currentLayout.autoCorrectPunctuation:true;this.app.console.log('InputMethodManager::currentIMEngine.activate()');imEngine.activate(this.app.layoutManager.currentModifiedLayout.autoCorrectLanguage,dataValues,{suggest:settingsValues.suggestionsEnabled,correct:settingsValues.correctionsEnabled,correctPunctuation:correctPunctuation});}
if(typeof imEngine.selectionChange==='function'){this.app.inputContext.addEventListener('selectionchange',this);}
if(typeof imEngine.surroundingtextChange==='function'){this.app.inputContext.addEventListener('surroundingtextchange',this);}
this.currentIMEngine=imEngine;this.app.console.timeEnd('switchCurrentIMEngine'+switchStateId);}.bind(this));return p;};InputMethodManager.prototype.handleEvent=function(evt){this.app.console.info('InputMethodManager.handleEvent()',evt);switch(evt.type){case'selectionchange':this.app.console.log('InputMethodManager::currentIMEngine.selectionChange()',evt.detail);this.currentIMEngine.selectionChange(evt.detail);break;case'surroundingtextchange':this.app.console.log('InputMethodManager::currentIMEngine.surroundingtextChange()',evt.detail);this.currentIMEngine.surroundingtextChange(evt.detail);break;}};exports.InputMethods=InputMethods;exports.InputMethodGlue=InputMethodGlue;exports.InputMethodLoader=InputMethodLoader;exports.InputMethodManager=InputMethodManager;})(window);;'use strict';(function(exports){var SettingsPromiseManager=function SettingsPromiseManager(){this._readLock=null;this._writeLock=null;};SettingsPromiseManager.prototype._cleanLock=function(type){var propName;switch(type){case'read':propName='_readLock';break;case'write':propName='_writeLock';break;default:throw new Error('SettingsPromiseManager: Not such type.');}
if(this[propName]&&this[propName].closed){this[propName]=null;}};SettingsPromiseManager.prototype._getLock=function(type){var propName;switch(type){case'read':propName='_readLock';break;case'write':propName='_writeLock';break;default:throw new Error('SettingsPromiseManager: Not such type.');}
if(this[propName]&&!this[propName].closed){return this[propName];}
var settings=window.navigator.mozSettings;this[propName]=settings.createLock();return this[propName];};SettingsPromiseManager.prototype._getReadLock=function(){return this._getLock('read');};SettingsPromiseManager.prototype._getWriteLock=function(){return this._getLock('write');};SettingsPromiseManager.prototype.get=function(obj){if(typeof obj==='string'){return this.getOne(obj);}
if(typeof obj!=='object'){throw new Error('SettingsPromiseManager.get: '+'require object, array, or string.');}
var arr=Array.isArray(obj)?obj:Object.keys(obj);var promise=Promise.all(arr.map(function(key){return this.getOne(key);},this));return promise;};SettingsPromiseManager.prototype.getOne=function(key){var promise=new Promise(function(resolve,reject){var req=this._getReadLock().get(key);req.onsuccess=function(){this._cleanLock('read');resolve(req.result[key]);}.bind(this);req.onerror=function(){this._cleanLock('read');reject();}.bind(this);}.bind(this));return promise;};SettingsPromiseManager.prototype.set=function(obj,value){if(typeof obj==='string'){return this.setOne(obj,value);}
if(typeof obj!=='object'){throw new Error('SettingsPromiseManager.set: require object.');}
var promise=new Promise(function(resolve,reject){var req=this._getWriteLock().set(obj);req.onsuccess=function(){this._cleanLock('write');resolve();}.bind(this);req.onerror=function(){this._cleanLock('write');reject();}.bind(this);}.bind(this));return promise;};SettingsPromiseManager.prototype.setOne=function(key,value){var obj={};obj[key]=value;return this.set(obj);};var SettingsManagerBase=function(){this.initialized=false;this._callbacks=null;this._values={};this._initPromise=null;};SettingsManagerBase.prototype.onsettingchange=null;SettingsManagerBase.prototype.KEYS=[];SettingsManagerBase.prototype.PROPERTIES=[];SettingsManagerBase.prototype.getSettingsSync=function(){return this._values;};SettingsManagerBase.prototype.initSettings=function(){if(this._initPromise){return this._initPromise;}
var promise=this.promiseManager.get(this.KEYS).then(function(results){results.forEach(function(value,i){this._values[this.PROPERTIES[i]]=value;},this);this.startObserve();this.initialized=true;return this._values;}.bind(this),function(error){this._initPromise=null;return Promise.reject(error);}.bind(this));this._initPromise=promise;return promise;};SettingsManagerBase.prototype.startObserve=function(){if(this._callbacks){return;}
var callbacks=this._callbacks=[];this.KEYS.forEach(function(key,i){var callback=function(e){this._values[this.PROPERTIES[i]]=e.settingValue;if(typeof this.onsettingchange==='function'){this.onsettingchange(this._values);}}.bind(this);navigator.mozSettings.addObserver(key,callback);callbacks.push(callback);},this);};SettingsManagerBase.prototype.stopObserve=function(){if(!this._callbacks){return;}
var callbacks=this._callbacks;this.KEYS.forEach(function(key,i){navigator.mozSettings.removeObserver(key,callbacks[i]);},this);this._callbacks=null;};var SoundFeedbackSettings=function(){};SoundFeedbackSettings.prototype=new SettingsManagerBase();SoundFeedbackSettings.prototype.KEYS=['keyboard.clicksound','audio.volume.notification'];SoundFeedbackSettings.prototype.PROPERTIES=['clickEnabled','isSoundEnabled'];var VibrationFeedbackSettings=function(){};VibrationFeedbackSettings.prototype=new SettingsManagerBase();VibrationFeedbackSettings.prototype.KEYS=['keyboard.vibration'];VibrationFeedbackSettings.prototype.PROPERTIES=['vibrationEnabled'];var IMEngineSettings=function(){};IMEngineSettings.prototype=new SettingsManagerBase();IMEngineSettings.prototype.KEYS=['keyboard.wordsuggestion','keyboard.autocorrect'];IMEngineSettings.prototype.PROPERTIES=['suggestionsEnabled','correctionsEnabled'];exports.SettingsPromiseManager=SettingsPromiseManager;exports.SettingsManagerBase=SettingsManagerBase;exports.SoundFeedbackSettings=SoundFeedbackSettings;exports.VibrationFeedbackSettings=VibrationFeedbackSettings;exports.IMEngineSettings=IMEngineSettings;})(window);;'use strict';(function(exports){var VibrationFeedback=function(app){this.app=app;this.settings=null;};VibrationFeedback.prototype.VIBRATE_MS=50;VibrationFeedback.prototype.start=function(){var settings=this.settings=new VibrationFeedbackSettings();settings.promiseManager=this.app.settingsPromiseManager;settings.initSettings().catch(function rejected(){console.warn('VibrationFeedback: Failed to get initial settings.');});};VibrationFeedback.prototype.stop=function(){this.settings=null;};VibrationFeedback.prototype.triggerFeedback=function(){if(!this.settings.initialized){console.warn('VibrationFeedback: '+'Sound feedback needed but settings is not available yet.');return;}
if(typeof window.navigator.vibrate!=='function'){console.warn('VibrationFeedback: '+'No navigator.vibrate() on this platform.');return;}
var vibrationFeedbackSettingsValues=this.settings.getSettingsSync();if(!vibrationFeedbackSettingsValues.vibrationEnabled){return;}
window.navigator.vibrate(this.VIBRATE_MS);};var SoundFeedback=function(app){this.app=app;this.settings=null;this.clicker=null;this.specialClicker=null;};SoundFeedback.prototype.start=function(){var settings=this.settings=new SoundFeedbackSettings();settings.promiseManager=this.app.settingsPromiseManager;settings.onsettingchange=this._handleSettingsChange.bind(this);settings.initSettings().then(this._handleSettingsChange.bind(this),function rejected(){console.warn('SoundFeedback: Failed to get initial settings.');});};SoundFeedback.prototype.stop=function(){this.settings=null;this.clicker=null;this.specialClicker=null;};SoundFeedback.prototype.CLICK_SOUND_URL='./resources/sounds/key.wav';SoundFeedback.prototype.SPECIAL_SOUND_URL='./resources/sounds/special.opus';SoundFeedback.prototype.SPECIAL_KEY_CLASSNAME='special-key';SoundFeedback.prototype._handleSettingsChange=function(settings){if(settings.clickEnabled&&!!settings.isSoundEnabled){this.clicker=new Audio(this.CLICK_SOUND_URL);this.specialClicker=new Audio(this.SPECIAL_SOUND_URL);}else{this.clicker=null;this.specialClicker=null;}};SoundFeedback.prototype.triggerFeedback=function(target){if(!this.settings.initialized){console.warn('SoundFeedback: '+'Sound feedback needed but settings is not available yet.');return;}
if(!this.clicker&&!this.specialClicker){return;}
var isSpecialKey=target.classList.contains('special-key')||(parseInt(target.dataset.keyCode,10)<0);var clicker;if(!isSpecialKey){clicker=this.clicker;this.clicker=new Audio(this.CLICK_SOUND_URL);}else{clicker=this.specialClicker;this.specialClicker=new Audio(this.SPECIAL_SOUND_URL);}
clicker.play();};var FeedbackManager=function(app){this.app=app;this.vibrationFeedback=null;this.soundFeedback=null;};FeedbackManager.prototype.start=function(){this.vibrationFeedback=new VibrationFeedback(this.app);this.vibrationFeedback.start();this.soundFeedback=new SoundFeedback(this.app);this.soundFeedback.start();};FeedbackManager.prototype.stop=function(){this.settings=null;this.vibrationFeedback.stop();this.soundFeedback.stop();this.vibrationFeedback=null;this.soundFeedback=null;};FeedbackManager.prototype.triggerFeedback=function(target){this.vibrationFeedback.triggerFeedback(target);this.soundFeedback.triggerFeedback(target);};exports.VibrationFeedback=VibrationFeedback;exports.SoundFeedback=SoundFeedback;exports.FeedbackManager=FeedbackManager;})(window);;'use strict';(function(exports){var UpperCaseStateManager=function(){this.isUpperCase=undefined;this.isUpperCaseLocked=undefined;};UpperCaseStateManager.prototype.onstatechange=null;UpperCaseStateManager.prototype.start=UpperCaseStateManager.prototype.reset=function(){this.isUpperCase=false;this.isUpperCaseLocked=false;};UpperCaseStateManager.prototype.stop=function(){this.isUpperCase=undefined;this.isUpperCaseLocked=undefined;};UpperCaseStateManager.prototype.switchUpperCaseState=function(state){if(!state){return;}
var newIsUpperCase=(typeof state.isUpperCase==='boolean')?state.isUpperCase:this.isUpperCase;var newIsUpperCaseLocked=(typeof state.isUpperCaseLocked==='boolean')?state.isUpperCaseLocked:this.isUpperCaseLocked;if(newIsUpperCaseLocked){newIsUpperCase=true;}
var statechanged=(this.isUpperCase!==newIsUpperCase)||(this.isUpperCaseLocked!==newIsUpperCaseLocked);if(!statechanged){return;}
this.isUpperCase=newIsUpperCase;this.isUpperCaseLocked=newIsUpperCaseLocked;if(typeof this.onstatechange==='function'){this.onstatechange();}};exports.UpperCaseStateManager=UpperCaseStateManager;})(window);;'use strict';(function(exports){var CandidatePanelScrollingMonitor=function(app){this.app=app;this.scrollTimer=undefined;};CandidatePanelScrollingMonitor.prototype.SCROLL_END_WAIT_MS=200;CandidatePanelScrollingMonitor.prototype.onneedcandidates=null;CandidatePanelScrollingMonitor.prototype.start=function(){};CandidatePanelScrollingMonitor.prototype.stop=function(){clearTimeout(this.scrollTimer);if(IMERender.candidatePanel){IMERender.candidatePanel.removeEventListener('scroll',this);}};CandidatePanelScrollingMonitor.prototype.handleEvent=function(evt){var panel=evt.target;clearTimeout(this.scrollTimer);if(panel.scrollTop===0||(panel.scrollHeight-panel.clientHeight-panel.scrollTop)>=5){return;}
this.scrollTimer=setTimeout(function(){if(typeof this.onneedcandidates==='function'){this.onneedcandidates();}}.bind(this),this.SCROLL_END_WAIT_MS);};CandidatePanelScrollingMonitor.prototype.startMonitoring=function(){if('truncated'in IMERender.candidatePanel.dataset){IMERender.candidatePanel.addEventListener('scroll',this);}};CandidatePanelScrollingMonitor.prototype.stopMonitoring=function(){clearTimeout(this.scrollTimer);IMERender.candidatePanel.removeEventListener('scroll',this);};var CandidatePanelManager=function(app){this.app=app;this.currentCandidates=null;this.isFullPanelShown=undefined;this.scrollingMonitor=null;};CandidatePanelManager.prototype.FIRST_PAGE_ROWS=11;CandidatePanelManager.prototype.PAGE_ROWS=12;CandidatePanelManager.prototype.start=function(){this.currentCandidates=[];this.isFullPanelShown=false;this.scrollingMonitor=new CandidatePanelScrollingMonitor(this.app);this.scrollingMonitor.start();this.scrollingMonitor.onneedcandidates=this.showNextCandidatePage.bind(this);};CandidatePanelManager.prototype.stop=function(){this.scrollingMonitor.stop();this.scrollingMonitor=null;this.isFullPanelShown=undefined;};CandidatePanelManager.prototype.showNextCandidatePage=function(){var numberOfCandidatesPerRow=IMERender.getNumberOfCandidatesPerRow();var candidatePanel=IMERender.candidatePanel;var candidateIndicator=parseInt(candidatePanel.dataset.candidateIndicator,10);var engine=this.app.inputMethodManager.currentIMEngine;if(typeof engine.getMoreCandidates==='function'){engine.getMoreCandidates(candidateIndicator,this.PAGE_ROWS*numberOfCandidatesPerRow+1,IMERender.showMoreCandidates.bind(IMERender,this.PAGE_ROWS));}else{var list=this.currentCandidates.slice(candidateIndicator,candidateIndicator+this.PAGE_ROWS*numberOfCandidatesPerRow+1);IMERender.showMoreCandidates(this.PAGE_ROWS,list);}};CandidatePanelManager.prototype.toggleFullPanel=function(fullPanel){if(this.isFullPanelShown){this.hideFullPanel();}else{this.showFullPanel();}};CandidatePanelManager.prototype.showFullPanel=function(){if(this.isFullPanelShown){return;}
this.isFullPanelShown=true;var candidatePanel=IMERender.candidatePanel;if(candidatePanel.dataset.rowCount==1){var numberOfCandidatesPerRow=IMERender.getNumberOfCandidatesPerRow();var candidateIndicator=parseInt(candidatePanel.dataset.candidateIndicator,10);var engine=this.app.inputMethodManager.currentIMEngine;if(typeof engine.getMoreCandidates==='function'){engine.getMoreCandidates(candidateIndicator,this.FIRST_PAGE_ROWS*numberOfCandidatesPerRow+1,function gotMoreCandidates(list){if(candidatePanel.dataset.rowCount!=1){return;}
IMERender.showMoreCandidates(this.FIRST_PAGE_ROWS,list);this.scrollingMonitor.startMonitoring();IMERender.toggleCandidatePanel(true);}.bind(this));}else{var list=this.currentCandidates.slice(candidateIndicator,candidateIndicator+
this.FIRST_PAGE_ROWS*numberOfCandidatesPerRow+1);IMERender.showMoreCandidates(this.FIRST_PAGE_ROWS,list);this.scrollingMonitor.startMonitoring();IMERender.toggleCandidatePanel(true);}}else{this.scrollingMonitor.startMonitoring();IMERender.toggleCandidatePanel(true);}};CandidatePanelManager.prototype.hideFullPanel=function(){if(!this.isFullPanelShown){return;}
this.isFullPanelShown=false;this.scrollingMonitor.stopMonitoring();IMERender.toggleCandidatePanel(false);};CandidatePanelManager.prototype.updateCandidates=function(candidates){this.currentCandidates=candidates;this.showCandidates();};CandidatePanelManager.prototype.showCandidates=function(){IMERender.showCandidates(this.currentCandidates);};exports.CandidatePanelScrollingMonitor=CandidatePanelScrollingMonitor;exports.CandidatePanelManager=CandidatePanelManager;})(window);;'use strict';(function(exports){var LayoutRenderingManager=function(app){this.app=app;this._resizeListenerTimer=undefined;};LayoutRenderingManager.prototype.start=function(){this.app.console.log('LayoutRenderingManager.start()');this._resizeListenerTimer=setTimeout(function attachResizeListener(){this.app.console.log('LayoutRenderingManager.attachResizeListener()');window.addEventListener('resize',this);}.bind(this),2000);};LayoutRenderingManager.prototype.stop=function(){clearTimeout(this._resizeListenerTimer);this._resizeListenerTimer=undefined;window.removeEventListener('resize',this);};LayoutRenderingManager.prototype.handleEvent=function(){this.app.console.log('LayoutRenderingManager.handleEvent()');if(document.hidden){return;}
IMERender.resizeUI(this.app.layoutManager.currentModifiedLayout);this._updateHeight();this._updateLayoutParams();};LayoutRenderingManager.prototype.updateLayoutRendering=function(){this.app.console.log('LayoutRenderingManager.updateLayoutRendering()');this.app.console.time('LayoutRenderingManager.updateLayoutRendering()');var currentLayout=this.app.layoutManager.currentLayout;var currentModifiedLayout=this.app.layoutManager.currentModifiedLayout;var currentIMEngine=this.app.inputMethodManager.currentIMEngine;var needsCandidatePanel=!!((currentLayout.autoCorrectLanguage||currentLayout.needsCandidatePanel)&&((typeof currentIMEngine.displaysCandidates!=='function')||currentIMEngine.displaysCandidates()));var needsUpperCase=currentModifiedLayout.secondLayout?this.app.upperCaseStateManager.isUpperCase:true;var p=new Promise(function(resolve){IMERender.draw(currentModifiedLayout,{uppercase:needsUpperCase,inputType:this.app.getBasicInputType(),showCandidatePanel:needsCandidatePanel},resolve);}.bind(this)).then(this._afterRenderDrew.bind(this));IMERender.setInputMethodName(this.app.layoutManager.currentModifiedLayout.imEngine||'default');this.app.console.timeEnd('LayoutRenderingManager.updateLayoutRendering()');return p;};LayoutRenderingManager.prototype._afterRenderDrew=function(){this.app.console.log('LayoutRenderingManager._afterRenderDrew()');this.app.console.time('LayoutRenderingManager._afterRenderDrew()');IMERender.setUpperCaseLock(this.app.upperCaseStateManager);this._updateLayoutParams();this._updateHeight();this.app.candidatePanelManager.showCandidates();this.app.console.timeEnd('LayoutRenderingManager._afterRenderDrew()');};LayoutRenderingManager.prototype._updateLayoutParams=function(){this.app.console.log('LayoutRenderingManager._updateLayoutParams()');var currentIMEngine=this.app.inputMethodManager.currentIMEngine;var layoutManager=this.app.layoutManager;if((typeof currentIMEngine.setLayoutParams!=='function')||layoutManager.currentLayoutPage!==layoutManager.LAYOUT_PAGE_DEFAULT){return;}
var candidatePanel=IMERender.candidatePanel;var yBias=candidatePanel?candidatePanel.clientHeight:0;currentIMEngine.setLayoutParams({keyboardWidth:IMERender.getWidth(),keyboardHeight:(IMERender.getHeight()-yBias),keyArray:IMERender.getKeyArray(),keyWidth:IMERender.getKeyWidth(),keyHeight:IMERender.getKeyHeight()});};LayoutRenderingManager.prototype._updateHeight=function(){this.app.console.log('LayoutRenderingManager._updateHeight()');this.app.console.time('LayoutRenderingManager._updateHeight()');var imeHeight=IMERender.getHeight()+1;var imeWidth=IMERender.getWidth();this.app.console.timeEnd('LayoutRenderingManager._updateHeight()');this.app.console.timeEnd('activate');this.app.console.timeEnd('domLoading');window.resizeTo(imeWidth,imeHeight);};exports.LayoutRenderingManager=LayoutRenderingManager;})(window);;'use strict';(function(exports){var StateManager=function(app){this.app=app;this._isActive=undefined;this._layoutName=undefined;};StateManager.prototype.DEACTIVATE_DELAY=120;StateManager.prototype.start=function(){this.app.console.log('StateManager.start()');this._isActive=false;window.addEventListener('hashchange',this);window.addEventListener('visibilitychange',this);navigator.mozInputMethod.addEventListener('inputcontextchange',this);this.app.setInputContext(navigator.mozInputMethod.inputcontext);this._layoutName=window.location.hash.substr(1);var active=(!document.hidden&&!!this.app.inputContext);if(!active){this._preloadLayout().then(this.app.l10nLoader.load.bind(this.app.l10nLoader));}
this._updateActiveState(active);};StateManager.prototype.stop=function(){this.app.console.log('StateManager.stop()');window.removeEventListener('hashchange',this);window.removeEventListener('visibilitychange',this);navigator.mozInputMethod.removeEventListener('inputcontextchange',this);this._isActive=undefined;this._layoutName=undefined;};StateManager.prototype.handleEvent=function(evt){var active=(!document.hidden&&!!navigator.mozInputMethod.inputcontext);this.app.console.info('StateManager.handleEvent()',evt,active);switch(evt.type){case'hashchange':this._layoutName=window.location.hash.substr(1);if(!active){this._preloadLayout();}
break;case'visibilitychange':break;case'inputcontextchange':this.app.setInputContext(navigator.mozInputMethod.inputcontext);break;}
this._updateActiveState(active);};StateManager.prototype._updateActiveState=function(active){this.app.console.log('StateManager._updateActiveState()',active);if(active){this.app.console.time('activate');this.app.inputMethodManager.updateInputContextData();this.app.candidatePanelManager.hideFullPanel();this.app.candidatePanelManager.updateCandidates([]);this.app.layoutManager.switchCurrentLayout(this._layoutName).then(this._switchCurrentIMEngine.bind(this)).then(this._updateLayoutRendering.bind(this)).then(this.app.l10nLoader.load.bind(this.app.l10nLoader)).catch(function(e){(e!==undefined)&&console.error(e);});}else{if(active===this._isActive){return;}
this.app.settingsPromiseManager.set({'keyboard.current':undefined});var imManager=this.app.inputMethodManager;this._delayDeactivate().then(function(){this.app.console.log('StateManager._delayDeactivate()::then');this.app.candidatePanelManager.hideFullPanel();this.app.candidatePanelManager.updateCandidates([]);this.app.targetHandlersManager.activeTargetsManager.clearAllTargets();}.bind(this)).then(imManager.switchCurrentIMEngine.bind(imManager,'default')).catch(function(e){(e!==undefined)&&console.error(e);});}
this._isActive=active;};StateManager.prototype._delayDeactivate=function(){this.app.console.log('StateManager._delayDeactivate()');var p=new Promise(function(resolve,reject){setTimeout(function(){if(this._isActive){console.warn('StateManager: Reactivated before DEACTIVATE_DELAY.');reject();}
resolve();}.bind(this),this.DEACTIVATE_DELAY);}.bind(this));return p;};StateManager.prototype._preloadLayout=function(){this.app.console.log('StateManager._preloadLayout()');var layoutLoader=this.app.layoutManager.loader;var p=layoutLoader.getLayoutAsync(this._layoutName).then(function(layout){var imEngineName=layout.imEngine;var imEngineLoader=this.app.inputMethodManager.loader;if(imEngineName){var p=imEngineLoader.getInputMethodAsync(imEngineName);return p;}}.bind(this)).catch(function(e){if(e!==undefined){console.error(e);}});return p;};StateManager.prototype._switchCurrentIMEngine=function(){this.app.console.log('StateManager._switchCurrentIMEngine()');if(!this._isActive){return Promise.reject();}
var layout=this.app.layoutManager.currentModifiedLayout;var imEngineName=layout.imEngine||'default';this.app.upperCaseStateManager.reset();var p=this.app.inputMethodManager.switchCurrentIMEngine(imEngineName);return p;};StateManager.prototype._updateLayoutRendering=function(){this.app.console.log('StateManager._updateLayoutRendering()');if(!this._isActive){return Promise.reject();}
this.app.settingsPromiseManager.set({'keyboard.current':this.app.layoutManager.currentLayoutName});var p=this.app.layoutRenderingManager.updateLayoutRendering();return p;};exports.StateManager=StateManager;})(window);;'use strict';(function(exports){var KeyboardApp=function(){this.console=null;this.inputMethodManager=null;this.layoutManager=null;this.settingsPromiseManager=null;this.l10nLoader=null;this.targetHandlersManager=null;this.feedbackManager=null;this.visualHighlightManager=null;this.candidatePanelManager=null;this.upperCaseStateManager=null;this.layoutRenderingManager=null;this.stateManager=null;this.inputContext=null;};KeyboardApp.prototype.ACCENT_CHAR_MENU_ELEMENT_ID='keyboard-accent-char-menu';KeyboardApp.prototype.CONATINER_ELEMENT_ID='keyboard';KeyboardApp.prototype.start=function(){this._startComponents();};KeyboardApp.prototype._startComponents=function(){this.console=new KeyboardConsole();this.console.start();this.console.log('KeyboardApp._startComponents()');this.console.trace();this.console.time('KeyboardApp._startComponents()');this.settingsPromiseManager=new SettingsPromiseManager();this.inputMethodManager=new InputMethodManager(this);this.inputMethodManager.start();this.layoutManager=new LayoutManager(this);this.layoutManager.start();this.l10nLoader=new L10nLoader();this.targetHandlersManager=new TargetHandlersManager(this);this.targetHandlersManager.start();this.feedbackManager=new FeedbackManager(this);this.feedbackManager.start();this.visualHighlightManager=new VisualHighlightManager(this);this.visualHighlightManager.start();this.candidatePanelManager=new CandidatePanelManager(this);this.candidatePanelManager.start();this.upperCaseStateManager=new UpperCaseStateManager();this.upperCaseStateManager.onstatechange=this.handleUpperCaseStateChange.bind(this);this.upperCaseStateManager.start();this.layoutRenderingManager=new LayoutRenderingManager(this);this.layoutRenderingManager.start();IMERender.init();this.stateManager=new StateManager(this);this.stateManager.start();this.console.timeEnd('KeyboardApp._startComponents()');};KeyboardApp.prototype.stop=function(){this.console.log('KeyboardApp.stop()');this._stopComponents();this.inputContext=null;};KeyboardApp.prototype._stopComponents=function(){this.console=null;this.inputMethodManager=null;this.layoutManager=null;this.settingsPromiseManager=null;this.l10nLoader=null;this.targetHandlersManager.stop();this.targetHandlersManager=null;this.feedbackManager.stop();this.feedbackManager=null;this.visualHighlightManager.stop();this.visualHighlightManager=null;this.candidatePanelManager.stop();this.candidatePanelManager=null;this.upperCaseStateManager.onstatechange=null;this.upperCaseStateManager.stop();this.upperCaseStateManager=null;this.layoutRenderingManager.stop();this.layoutRenderingManager=null;this.stateManager.stop();this.stateManager=null;};KeyboardApp.prototype.getMenuContainer=function(){return document.getElementById(this.ACCENT_CHAR_MENU_ELEMENT_ID);};KeyboardApp.prototype.getContainer=function(){return document.getElementById(this.CONATINER_ELEMENT_ID);};KeyboardApp.prototype.setInputContext=function(inputContext){this.console.log('KeyboardApp.setInputContext()',inputContext);this.inputContext=inputContext;};KeyboardApp.prototype.getBasicInputType=function(){if(!this.inputContext){return'text';}
var type=this.inputContext.inputType;switch(type){case'url':case'tel':case'email':case'text':case'search':break;case'password':default:type='text';break;case'number':case'range':type='number';break;}
return type;};KeyboardApp.prototype.supportsSwitching=function(){return navigator.mozInputMethod.mgmt.supportsSwitching();};KeyboardApp.prototype.setLayoutPage=function setLayoutPage(page){this.console.log('KeyboardApp.setLayoutPage()',page);this.layoutManager.updateLayoutPage(page);this.layoutRenderingManager.updateLayoutRendering();var engine=this.inputMethodManager.currentIMEngine;if(typeof engine.setLayoutPage==='function'){engine.setLayoutPage(this.layoutManager.currentLayoutPage);}};KeyboardApp.prototype.getNumberOfCandidatesPerRow=function(){return IMERender.getNumberOfCandidatesPerRow();};KeyboardApp.prototype.handleUpperCaseStateChange=function(){this.console.log('KeyboardApp.handleUpperCaseStateChange()');if(this.layoutManager.currentModifiedLayout.secondLayout){this.layoutRenderingManager.updateLayoutRendering();return;}
window.requestAnimationFrame(function(){this.console.time('setUpperCase:requestAnimationFrame:callback');IMERender.setUpperCaseLock(this.upperCaseStateManager);this.candidatePanelManager.showCandidates();this.console.timeEnd('setUpperCase:requestAnimationFrame:callback');}.bind(this));};exports.KeyboardApp=KeyboardApp;})(window);;'use strict';(function(exports){var app=new KeyboardApp();app.start();exports.app=app;})(window);